﻿--
-- REA Script
-- author: 900Hasse
-- date: 30.07.2019
--
-- V1.0.0.0
--
-----------------------------------------
-- TO DO
---------------
-- 
-- Remake combine power need?
-- Check translation wheel.drivenode relative wheel.node
-- Add more bounce to smaller wheels
-- Somehow make vehicles get more inertia and momentum


-----------------------------------------
-- KNOWN ISSUES
---------------
-- Combines harveters get to high power demand on cutter?
-- 
-- 	

print("---------------------------")
print("----- REA by 900Hasse -----")
print("---------------------------")
REA = {};

function REA.prerequisitesPresent(specializations)
    return true
end;

function REA:loadMap(name)
end

function REA:deleteMap()
end

function REA:draw(dt)
end;

function REA:update(dt)

	-- Exchange standard GIANT'S functions for editet by REA
	if REA.FunctionsChanged ~= true then
		-- Change Giant's "UpdateGear" to "REAUpdateGear"
		VehicleMotor.updateGear = REA.REAupdateGear;
		-- Change Giant's "updateWheelSink" to "REAupdateWheelSink"
		Wheels.updateWheelSink = REA.REAupdateWheelSink;
		-- Change Giant's "UpdateSpeedGauge" for REA "UpdateSpeedGauge"
		SpeedMeterDisplay.updateSpeedGauge = REA.updateSpeedGauge;

		-- Standard functions exchanged
		REA.FunctionsChanged = true;
		print("New REA functions loaded")
	end;

	-- If Client draw vehicle status on GUI
	-- Disabled undtil further development
	local UseGUI = false;
	if g_client and UseGUI then
		-- Check number of vehicles
		numVehicles = table.getn(g_currentMission.vehicles);
		-- If vehicles present run code
		if numVehicles ~= nil then
			-- Run code for vehicles
			if numVehicles >= 1 then
				-- Search for controlled vehicle
				for VehicleIndex=1, numVehicles do
					-- Spara "vehicle" lokalt
					local vehicle = g_currentMission.vehicles[VehicleIndex];			
					-- Kontrollera om aktuellt fordon finns
					if vehicle ~= nil then
						if vehicle.spec_motorized then
							if vehicle.spec_wheels ~= nil then	
								if vehicle:getIsControlled() then
									if g_currentMission.controlledVehicle == vehicle then
										REA:DrawStatus(vehicle,dt);
										break
									end;
								end;
							end;
						end;
					end;
				end;
			end;
		end;
	end;

	-- If server run code for vehicles
	if g_server ~= nil then
		-- Save global values
		if REA.GlobalValuesSet ~= true then
			-- TireType sink parameters
			REA.TireTypeMaxSinkFrictionReduced = {1,1,1,1};
			REA.TireTypeSinkStuckLevel = {1,1,1,1};
			REA.TireTypeMinRollingCoeff = {1,1,1,1};

			-- Friction multipliers for implements
			REA.PlowMultiplier = {1,1,1,1,1,1};
			REA.CultivatorMultiplier = {1,1,1,1,1,1};
			REA.SowingMachineMultiplier = {1,1,1,1,1,1};
			-- Speed adjustments for implements
			REA.PlowSpeedAjust = {0,0,0,0,0,0};
			REA.CultivatorSpeedAjust = {0,0,0,0,0,0};
			REA.SowingMachineSpeedAjust = {0,0,0,0,0,0};
			-- Power need per 1000l fillspeed
			REA.FillSpeedPowerNeed = {};

			-- Tiretypes
			local TireTypeMUD = 1;
			local TireTypeOFFROAD = 2;
			local TireTypeSTREET = 3;
			local TireTypeCRAWLER = 4;

			-- Groundtypes
			local ROAD = 1;
			local HARD_TERRAIN = 2;
			local SOFT_TERRAIN = 3;
			local FIELD = 4;

			-- Terrain values
			local Road = 0 -- Road
			local Cultivated = 1 -- Cultivated
			local Plowed = 2 -- Plowed
			local HarvestedSowed = 3 -- Harvested or sowed
			local RootCrops = 4 -- Rootcrops
			local Grass = 5 -- Grass

			-----------------------------------------------------------------------------------
			-- Global settings of wheel tiretypes and friction
			-----------------------------------------------------------------------------------
			-------------------------------------
			-- MUD
			-- TireType on different groundtypes
			WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffs[ROAD] = 1.0;
			WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffs[HARD_TERRAIN] = 0.8;
			WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffs[SOFT_TERRAIN] = 0.7;
			WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffs[FIELD] = 0.7;
			WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffsWet[ROAD] = WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffs[ROAD]*0.9;
			WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffsWet[HARD_TERRAIN] = WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffs[HARD_TERRAIN]*0.9;
			WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffsWet[SOFT_TERRAIN] = WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffs[SOFT_TERRAIN]*0.9;
			WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffsWet[FIELD] = WheelsUtil.tireTypes[TireTypeMUD].frictionCoeffs[FIELD]*0.9;
			-- Sink parameters (percentage)
			REA.TireTypeMaxSinkFrictionReduced[TireTypeMUD] = 50;
			REA.TireTypeSinkStuckLevel[TireTypeMUD] = 101;
			-- Min rolling coefficient
			REA.TireTypeMinRollingCoeff[TireTypeMUD] = 0.04;
			-------------------------------------
			-- OFFROAD
			-- TireType on different groundtypes
			WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffs[ROAD] = 1.25;
			WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffs[HARD_TERRAIN] = 0.8;
			WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffs[SOFT_TERRAIN] = 0.6;
			WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffs[FIELD] = 0.6;
			WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffsWet[ROAD] = WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffs[ROAD]*0.9;
			WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffsWet[HARD_TERRAIN] = WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffs[HARD_TERRAIN]*0.8;
			WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffsWet[SOFT_TERRAIN] = WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffs[SOFT_TERRAIN]*0.8;
			WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffsWet[FIELD] = WheelsUtil.tireTypes[TireTypeOFFROAD].frictionCoeffs[FIELD]*0.7;
			-- Sink parameters (percentage)
			REA.TireTypeMaxSinkFrictionReduced[TireTypeOFFROAD] = 80;
			REA.TireTypeSinkStuckLevel[TireTypeOFFROAD] = 101;
			-- Min rolling coefficient
			REA.TireTypeMinRollingCoeff[TireTypeOFFROAD] = 0.03;
			-------------------------------------
			-- STREET
			-- TireType on different groundtypes
			WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffs[ROAD] = 1.5;
			WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffs[HARD_TERRAIN] = 0.7;
			WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffs[SOFT_TERRAIN] = 0.5;
			WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffs[FIELD] = 0.5;
			WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffsWet[ROAD] = WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffs[ROAD]*0.9;
			WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffsWet[HARD_TERRAIN] = WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffs[HARD_TERRAIN]*0.8;
			WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffsWet[SOFT_TERRAIN] = WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffs[SOFT_TERRAIN]*0.8;
			WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffsWet[FIELD] = WheelsUtil.tireTypes[TireTypeSTREET].frictionCoeffs[FIELD]*0.7;
			-- Sink parameters (percentage)
			REA.TireTypeMaxSinkFrictionReduced[TireTypeSTREET] = 95;
			REA.TireTypeSinkStuckLevel[TireTypeSTREET] = 75;
			-- Min rolling coefficient
			REA.TireTypeMinRollingCoeff[TireTypeSTREET] = 0.02;
			-------------------------------------
			-- CRAWLER
			-- TireType on different groundtypes
			WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffs[ROAD] = 1.0;
			WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffs[HARD_TERRAIN] = 1.0;
			WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffs[SOFT_TERRAIN] = 0.9;
			WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffs[FIELD] = 0.9;
			WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffsWet[ROAD] = WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffs[ROAD]*0.7;
			WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffsWet[HARD_TERRAIN] = WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffs[HARD_TERRAIN]*0.8;
			WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffsWet[SOFT_TERRAIN] = WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffs[SOFT_TERRAIN]*0.8;
			WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffsWet[FIELD] = WheelsUtil.tireTypes[TireTypeCRAWLER].frictionCoeffs[FIELD]*0.8;
			-- Sink parameters (percentage)
			REA.TireTypeMaxSinkFrictionReduced[TireTypeCRAWLER] = 30;
			REA.TireTypeSinkStuckLevel[TireTypeCRAWLER] = 101;
			-- Min rolling coefficient
			REA.TireTypeMinRollingCoeff[TireTypeCRAWLER] = 0.05;


			-----------------------------------------------------------------------------------
			-- Settings for implement and groundtype
			-----------------------------------------------------------------------------------
			-- Pulling multiplier on different groundtypes
			-- Plow
			REA.PlowMultiplier[Plowed] = 0.7;
			REA.PlowMultiplier[Cultivated] = 0.8;
			REA.PlowMultiplier[RootCrops] = 0.9;
			REA.PlowMultiplier[HarvestedSowed] = 1;
			REA.PlowMultiplier[Grass] = 1.2;
			REA.PlowMultiplier[Road] = 1.3;
			-- Cultivator
			REA.CultivatorMultiplier[Plowed] = 0.7;
			REA.CultivatorMultiplier[Cultivated] = 0.8;
			REA.CultivatorMultiplier[RootCrops] = 0.9;
			REA.CultivatorMultiplier[HarvestedSowed] = 1;
			REA.CultivatorMultiplier[Grass] = 1.3;
			REA.CultivatorMultiplier[Road] = 2;
			-- Sowing machine
			REA.SowingMachineMultiplier[Plowed] = 0.6;
			REA.SowingMachineMultiplier[Cultivated] = 1;
			REA.SowingMachineMultiplier[RootCrops] = 1;
			REA.SowingMachineMultiplier[HarvestedSowed] = 1.2;
			REA.SowingMachineMultiplier[Grass] = 1.4;
			REA.SowingMachineMultiplier[Road] = 2;

			-- Global values set
			REA.GlobalValuesSet = true
			print("Global REA variables loaded")
		end;

		-- Get highest sink value
		local numMaxSink = table.getn(Wheels.MAX_SINK);
		local maxSink = 0.2 * 1.3;
		for Terrain=1,numMaxSink do
			if Wheels.MAX_SINK[Terrain] > maxSink then
				-- Save current maxSink as new maxSink with plowing effect
				maxSink = Wheels.MAX_SINK[Terrain] * 1.3;
			end;
		end;

		-- Determine number of vehicles
		numVehicles = table.getn(g_currentMission.vehicles);
		-- Run wheel functions if vehicles present
		if numVehicles ~= nil then
			if numVehicles >= 1 then		
				-----------------------------------------------------------------------------------	
				-- Add wheel functions
				-----------------------------------------------------------------------------------
				for VehicleIndex=1, numVehicles do
					-- Save "vehicle" local
					local vehicle = g_currentMission.vehicles[VehicleIndex];			
					-- Check if active vehicle
					if vehicle ~= nil then					
						local MotorizedVehicle = false;
						-- If vehicle is motorized save speed to use for shifting gear
						if vehicle.spec_motorized ~= nil then
							if vehicle.spec_motorized.motor ~= nil then

--								!IN DEVELOPMENT!
--								if vehicle:getIsControlled()  then
--									local TotalMass = 0;
--									for _, component in ipairs(vehicle.components) do
--										TotalMass = component.mass + TotalMass;										
--										renderText(0.2, 0.10, 0.03,"angular damping: " .. getAngularDamping(component.node));
--										renderText(0.2, 0.15, 0.03,"linear damping: " .. getLinearDamping(component.node));
--									end;
--									renderText(0.2, 0.20, 0.03,"Total mass: " .. TotalMass);
--								end;

								-- If vehicle is not motorized increase friction to avoid gliding
								MotorizedVehicle = true;
								-- Check if implements attached and if it is working
								vehicle.spec_motorized.motor.ImplementIsWorking = REA:GetImplementWorking(vehicle);
								-- Adjust speed of vehicle if PTO demands more power than motor can give
								if vehicle.spec_motorized.isMotorStarted then
									-- Adjust speed if PTO tourqe reaches high levels
									REA:AdjustSpeedIfPtpPowerMaxed(vehicle,dt);
								end;
							end;
						end;
						-- If vehicle have wheels calculate friction and add rolling resistance
						if vehicle.spec_wheels ~= nil then	
							-- If vehicle is a powerconsumer and rolling resistance should be ignored when implement is working
							local IgnoreRollingResistance = false;
							if vehicle.spec_powerConsumer ~= nil then
								if vehicle.spec_powerConsumer.IgnoreRollingResistance ~= nil then
									IgnoreRollingResistance = vehicle.spec_powerConsumer.IgnoreRollingResistance;
								end;
							end;
							REA:UpdateWheels(vehicle.spec_wheels,MotorizedVehicle,maxSink,IgnoreRollingResistance,dt);
						end;
						-- Adjust power need and speed of power consuming vehicle
						REA:UpdatePowerMultiplier(vehicle,dt);
					end;
				end;
			end;
		end;
	end;
end;


-----------------------------------------------------------------------------------	
-- Draw status of vehicle
-----------------------------------------------------------------------------------
function REA:DrawStatus(vehicle,dt)
	-- Used motor
	local motor = vehicle.spec_motorized.motor;

	--------------------------------------------------------------------
	-- Init global variables
	--------------------------------------------------------------------
	if vehicle.timer == nil or vehicle.GUISlip == nil or vehicle.GUICurrentGear == nil or vehicle.GUINumberOfGears == nil then
		vehicle.timer = 0;
		vehicle.GUISlip = 0;
		vehicle.GUIMotorLoad = 0;
		vehicle.GUICurrentGear = 0;
		vehicle.GUINumberOfGears = 0;
	end;

	--------------------------------------------------------------------
	-- Get engine RPM
	--------------------------------------------------------------------
	-- Get actual RPM
	local RPM = 0;
	if motor.RPMGaugeSmoothed ~= nil then
		RPM = motor.RPMGaugeSmoothed;
	else
		RPM = motor.lastMotorRpm;
	end;
	-- Get min and max RPM
	local minRpm = motor.minRpm;
	local maxRpm = motor.maxRpm;
	-- Calculate RPM percentage
	local PRMPercentage = ((RPM - minRpm) / (maxRpm - minRpm));
	-- Calculate motor load
	local MotorLoad = REA:RoundValue((vehicle.spec_motorized.smoothedLoadPercentage * PRMPercentage) * 100);
	-- Motor load is 0-100%
	if MotorLoad > 100 then
		MotorLoad = 100;
	elseif MotorLoad < 0 then
		MotorLoad = 0;
	end

	--------------------------------------------------------------------
	-- Calculate slip
	--------------------------------------------------------------------
	-- How many wheels do the vehicle have
	local numWheels = table.getn(vehicle.spec_wheels.wheels);
	-- Get speed
	local VehicleSpeed = vehicle:getLastSpeed();
	-- Loop to get fastest moving wheel
	local WheelNotMoving = false;
	local WheelMovingForward = false;
	local WheelMovingBackward = false;
	local HighestWheelSpeed = 0;
	local HighestWheelSpeedSigned = 0;
	for Wheel=1,numWheels do
		-- Save active wheel to local wheel
		local Actwheel = vehicle.spec_wheels.wheels[Wheel];
		-- Calculate speed of wheel
		local wheelSpeedSigned = (((Actwheel.radius * 100) * 2) * Actwheel.netInfo.xDriveSpeed * 0.001885) * 9.5493;
		local wheelSpeed = math.abs(wheelSpeedSigned);
		-- Get highest wheel speed
		if wheelSpeed > HighestWheelSpeed then
			HighestWheelSpeed = wheelSpeed;
			HighestWheelSpeedSigned = wheelSpeedSigned;
		end;
	end;
	-- Smoothe wheelspeed
	vehicle.spec_wheels.HighestWheelspeedSmoothed = REA:SmootheValue(vehicle.spec_wheels.HighestWheelspeedSmoothed,HighestWheelSpeed);
	vehicle.spec_wheels.HighestWheelspeedSignedSmoothed = REA:SmootheValue(vehicle.spec_wheels.HighestWheelspeedSignedSmoothed,HighestWheelSpeedSigned);
	-- Get moving direction of wheel
	if vehicle.spec_wheels.HighestWheelspeedSignedSmoothed > 0.5 then
		WheelMovingForward = true;
	elseif vehicle.spec_wheels.HighestWheelspeedSignedSmoothed < -0.5 then
		WheelMovingBackward = true;
	else
		WheelNotMoving = true;
	end;
	-- Calculate slip
	local Slip = 0;
	if VehicleSpeed > 0.25 and vehicle.spec_wheels.HighestWheelspeedSmoothed > 0.25 then
		Slip = VehicleSpeed / vehicle.spec_wheels.HighestWheelspeedSmoothed;
	end;
	-- Smoothe slip
	vehicle.spec_wheels.SlipSmoothed = REA:RoundValue(REA:SmootheValue(vehicle.spec_wheels.SlipSmoothed,100 - (Slip*100)));
	-- Slip is 0-100%
	if vehicle.spec_wheels.SlipSmoothed > 100 then
		vehicle.spec_wheels.SlipSmoothed = 100;
	elseif vehicle.spec_wheels.SlipSmoothed < 0 then
		vehicle.spec_wheels.SlipSmoothed = 0;
	end

	--------------------------------------------------------------------
	-- Gears
	--------------------------------------------------------------------
	-- Make gearratios
	if motor.GearboxCreated == nil then
		-- Print data
		print("----------------------")
		print("Gearbox created by REA in client")
		--
		-- Min och Max speed of motor
		local MaxForwardSpeed = (motor.maxForwardSpeed*3.6);
		local MaxBackwardSpeed = (motor.maxBackwardSpeed*3.6);
		-- Print data
		print("Forward:")
		local forwardGearRatios = REA:CreateRatioTable(MaxForwardSpeed,minRpm,maxRpm,325,false);
		-- Print data
		print("Backward:")
		local backwardGearRatios = REA:CreateRatioTable(MaxBackwardSpeed,minRpm,maxRpm,325,true);
		-- Save gear ratios
		motor.gearRatiosForward = forwardGearRatios;
		motor.gearRatiosBackward = backwardGearRatios;
		print("----------------------")
		-- Gearbox created
		motor.GearboxCreated = true;
	end;
	-- Calculate number of gears and current gear
	if motor.CurrentGearTimer == nil then
		motor.CurrentGearTimer = 0;
		motor.LastFoundGear = 0;
		motor.CurrentGear = 0;
		motor.NumberOfGears = 0;
		motor.UseGearsForward = false;
		motor.UseGearsBackward = false;
	end;
	-- Determine if moving forward or backward
	if MotorLoad > 3 then
		if WheelMovingForward then
			if not motor.UseGearsForward then
				motor.UseGearsForward = true;
				motor.UseGearsBackward = false;
				motor.LastFoundGear = 0;
				motor.CurrentGear = 0;
			end;
		elseif WheelMovingBackward then
			if not motor.UseGearsBackward then
				motor.UseGearsForward = false;
				motor.UseGearsBackward = true;
				motor.LastFoundGear = 0;
				motor.CurrentGear = 0;
			end;
		end;
	end;
	-- If vehicle is moving calculate gear
	local StartGearTimer = false;
	if motor.UseGearsForward or motor.UseGearsBackward then
		local GearRatios;
		-- determine if vehicle is moving forward or backward
		if motor.UseGearsForward then
			GearRatios = motor.gearRatiosForward;
		elseif motor.UseGearsBackward then
			GearRatios = motor.gearRatiosBackward;
		end;
		-- Get number of gears
		motor.NumberOfGears = table.getn(GearRatios);
		-- Calculate gears to search closest gear ratio
		local StartSearchGear = 1;
		local EndSearchGear = 1;
		if motor.CurrentGear > 0 then
			if motor.CurrentGear > 1 and motor.CurrentGear < motor.NumberOfGears then
				StartSearchGear = motor.CurrentGear - 1;
				EndSearchGear = motor.CurrentGear + 1;
			elseif motor.CurrentGear == motor.NumberOfGears then
				StartSearchGear = motor.CurrentGear - 1;
				EndSearchGear = motor.CurrentGear;
			elseif motor.CurrentGear == 1 then
				StartSearchGear = motor.CurrentGear;
				EndSearchGear = motor.CurrentGear + 1;
			end;
		end;
		-- Search for the gear with the gearratio closest to the calculated based on wheel speed
		local SmallestDifferance = 0;
		local SmallestDifferanceGearNumber = 0;
		for GearNumber=StartSearchGear,EndSearchGear do
			-- Calculate gearratio differance
			local GearboxGearRatio = GearRatios[GearNumber];
			local CalculatedGearRation = RPM / (vehicle.spec_wheels.HighestWheelspeedSmoothed * 2.653);
			local GearRatioDiff = math.abs(GearboxGearRatio - CalculatedGearRation);
			-- Save gearratio differance and gear number
			if SmallestDifferanceGearNumber == 0 then
				SmallestDifferance = GearRatioDiff;
				SmallestDifferanceGearNumber = GearNumber;
			elseif GearRatioDiff < SmallestDifferance then
				SmallestDifferance = GearRatioDiff;
				SmallestDifferanceGearNumber = GearNumber;
			end;
		end;
		-- If found gear is same as last time start timer
		if SmallestDifferanceGearNumber > 0 and SmallestDifferanceGearNumber == motor.LastFoundGear then
			StartGearTimer = true;
		end;
		-- Save last gear
		motor.LastFoundGear = SmallestDifferanceGearNumber;
	end;
	-- Filter time for for current gear
	if StartGearTimer then
		motor.CurrentGearTimer = motor.CurrentGearTimer + dt;
		-- Timer ready, save gear as current
		if motor.CurrentGearTimer > 500 then
			motor.CurrentGear = motor.LastFoundGear;
			-- Restart timer
			motor.CurrentGearTimer = 0;
		end;
	else
		-- Restart timer
		motor.CurrentGearTimer = 0;
	end;

	--------------------------------------------------------------------
	-- Uppdate every 100ms
	if vehicle.timer > 100 then
		--------------------------------------------------------------------
		-- Gears
		if motor.CurrentGear ~= nil and motor.NumberOfGears then
			vehicle.GUICurrentGear = motor.CurrentGear;
			vehicle.GUINumberOfGears = motor.NumberOfGears;
		end;
		-- slip
		if vehicle.spec_wheels.SlipSmoothed ~= nil then
			vehicle.GUISlip = vehicle.spec_wheels.SlipSmoothed;
		end;
		-- Motor load
		if MotorLoad ~= nil then
			vehicle.GUIMotorLoad = MotorLoad;
		end;
		-- Reset timer
		vehicle.timer = 0;
	end;
	-- Add time
	vehicle.timer = vehicle.timer + dt;

	--------------------------------------------------------------------
	-- Write GUI
	local OffsetSideways = 0.65;
	local TextSize = 0.02;
	-- Draw number of gears and active gear
	renderText(OffsetSideways, 0.16, TextSize,"Gear: " .. vehicle.GUICurrentGear .. " / " .. vehicle.GUINumberOfGears);
	-- Draw motor load
	if vehicle.GUIMotorLoad < 10 then
		renderText(OffsetSideways, 0.13, TextSize,"Motor load:   " .. vehicle.GUIMotorLoad .. "%");
	elseif vehicle.GUIMotorLoad > 99 then
		renderText(OffsetSideways, 0.13, TextSize,"Motor load: " .. vehicle.GUIMotorLoad .. "%");
	else
		renderText(OffsetSideways, 0.13, TextSize,"Motor load:  " .. vehicle.GUIMotorLoad .. "%");
	end;
	-- Draw slip
	if vehicle.GUISlip < 10 then
		renderText(OffsetSideways, 0.10, TextSize,"Slip:   " .. vehicle.GUISlip .. "%");
	elseif vehicle.GUISlip > 99 then
		renderText(OffsetSideways, 0.10, TextSize,"Slip: " .. vehicle.GUISlip .. "%");
	else
		renderText(OffsetSideways, 0.10, TextSize,"Slip:  " .. vehicle.GUISlip .. "%");
	end;
end

-----------------------------------------------------------------------------------	
-- Function to calculate friction and add rolling resistance
-----------------------------------------------------------------------------------
function REA:UpdateWheels(spec_wheels,MotorizedVehicle,maxSink,IgnoreRollingResistance,dt)
	
	-- How many wheels do the vehicle have
	local numWheels = table.getn(spec_wheels.wheels);

	-- Loop to calculate and update fricton, rolling resistance and sideway resistance for each wheel
	for Wheel=1,numWheels do
		-- Save to local variable wheel
		local wheel = spec_wheels.wheels[Wheel];
		-- Read width and Radius to use when calculating frictino
		local ActWheeleWidth = wheel.width;
		local ActWheeleRadius = wheel.radiusOriginal;
		-- Read sink into the ground
		local ActWheelSink = 0.01;
		if wheel.sink ~= nil then
			ActWheelSink = wheel.sink;
		end;
		-- Update sideway speed and direction of active wheel
		REA:UpdateWheelDirectionAndSpeed(wheel,dt);

		------------------------------------------------------
		-- Change values for PerlinNoise depending on size of wheel and ground type
		------------------------------------------------------
		-- Update if wheel is moving
		if (wheel.RollingDirectionSpeed >= 0.2 or wheel.SideWaySpeed >= 0.2) and wheel.lastTerrainValue ~= nil then
			-- Terrain values
			local Road = 0
			local Cultivated = 1
			local Plowed = 2
			local HarvestedSowed = 3
			local RootCrops = 4
			local Grass = 5

			-- Original values for Perlin noise
			local OrgPerlinNoiseSink = {randomSeed = 123,randomFrequency = 0.2,persistence = 0,numOctaves = 2};
			local OrgPerlinNoiseWobble = {randomSeed = 321,randomFrequency = 0.8,persistence = 0,numOctaves = 4};

			-- Load original values
			wheel.perlinNoiseSink = OrgPerlinNoiseSink;
			wheel.perlinNoiseWobble = OrgPerlinNoiseWobble;

--			IN DEVELOPMENT
--			-- Settings för perlin sink
--			local MaxSink = 0;
--			if wheel.lastTerrainValue >= 1 and wheel.lastTerrainValue <= 5 then
--				MaxSink = Wheels.MAX_SINK[wheel.lastTerrainValue];
--				-- Cultivated
--				if wheel.lastTerrainValue == Cultivated then
--					wheel.perlinNoiseSink.randomFrequency = 0.5;
--					wheel.perlinNoiseSink.persistence = 0.0;
--					wheel.perlinNoiseSink.numOctaves = 2;
--				-- Plowed
--				elseif wheel.lastTerrainValue == Plowed then
--					wheel.perlinNoiseSink.randomFrequency = 0.3;
--					wheel.perlinNoiseSink.persistence = 0.0;
--					wheel.perlinNoiseSink.numOctaves = 2;
--				-- Harvested / Planted
--				elseif wheel.lastTerrainValue == HarvestedSowed then
--					wheel.perlinNoiseSink.randomFrequency = 0.8;
--					wheel.perlinNoiseSink.persistence = 0.0;
--					wheel.perlinNoiseSink.numOctaves = 2;
--				-- Rootcrops
--				elseif wheel.lastTerrainValue == RootCrops then
--					wheel.perlinNoiseSink.randomFrequency = 0.3;
--					wheel.perlinNoiseSink.persistence = 0.0;
--					wheel.perlinNoiseSink.numOctaves = 2;
--				-- Grass
--				elseif wheel.lastTerrainValue == Grass then
--					wheel.perlinNoiseSink.randomFrequency = 0.8;
--					wheel.perlinNoiseSink.persistence = 0.0;
--					wheel.perlinNoiseSink.numOctaves = 2;
--				end;
--			end;
		end;

		------------------------------------------------------
		-- Calculate and update friction for wheel
		------------------------------------------------------
		-- Calculate friction of wheel
		if MotorizedVehicle then
			------------------------------------------------------
			-- Friction calculation
			local TireFriction = (ActWheeleWidth*2)+(ActWheeleRadius/2);
			-- If additinal wheels add more friction
			if wheel.additionalWheels ~= nil then
				local numAdditionalWheels = table.getn(wheel.additionalWheels);
				TireFriction = TireFriction+(numAdditionalWheels*(TireFriction*0.5));
			end;
			------------------------------------------------------
			-- Sink Friction calculation
			-- Read parameters for current tiretype
			ActWheelMaxSinkReducedFrictionPercentage = REA.TireTypeMaxSinkFrictionReduced[wheel.tireType];
			ActWheelStuckPerectangeLevel = REA.TireTypeSinkStuckLevel[wheel.tireType];
			-- Calculate sink percentage
			local ActWheelSinkPercentage = (ActWheelSink / maxSink)*100;
			local FrictionFactorBySink = 1;
			-- Calculate reduced friction casued by sink
			if ActWheelSinkPercentage < ActWheelStuckPerectangeLevel then
				FrictionFactorBySink = 1-((ActWheelMaxSinkReducedFrictionPercentage*(ActWheelSinkPercentage/100))/100);
			else
				FrictionFactorBySink = 0;
			end;
			------------------------------------------------------
			-- Add the calculated friction to wheel
			wheel.frictionScale = TireFriction*FrictionFactorBySink;
		-- If vehicle not motorized use higher friction to avoid strange behavior when towing
		else
			-- use default value
		end;

		------------------------------------------------------
		-- Rolling resistance for wheele
		------------------------------------------------------
		-- If wheele got contact with ground or object add rolling resistance
		if wheel.contact == Wheels.WHEEL_GROUND_CONTACT or wheel.contact == Wheels.WHEEL_OBJ_CONTACT then
			-- If there is a load on the wheel add force
			if getWheelShapeContactForce(wheel.node, wheel.wheelShape) ~= nil then
				------------------------------------------------------
				-- Save load on wheel to use for rolling resistance calculation
				local ActWheeleLoad = getWheelShapeContactForce(wheel.node, wheel.wheelShape);
				-- Rolling reistance coefficient = sqrt(WheelSink(m)*((WheelRadius(m)*2)))
				-- Calculate coefficient
				local ActWheelRollConf = math.sqrt(ActWheelSink/(ActWheeleRadius*2));
				-- If coefficient to low use min value 
				if ActWheelRollConf < REA.TireTypeMinRollingCoeff[wheel.tireType] then
					ActWheelRollConf  = REA.TireTypeMinRollingCoeff[wheel.tireType];
				end;
				-- Rolling resistance(kN) = coefficient*(Wheelload(kN)/WheelRadius(m))
				-- Calculate rolling resistance
				local ActWheelRollForce = ActWheelRollConf*(ActWheeleLoad/ActWheeleRadius);
				-- In case of negative force, use zero force
				if ActWheelRollForce < 0 then
					ActWheelRollForce = 0;
				end;

				------------------------------------------------------
				-- Get translation where force should be added
				local WheelX, WheelY, WheelZ = getTranslation(wheel.driveNode)

				------------------------------------------------------
				-- If the wheel is moving in rolling direction add force
				if wheel.RollingDirectionSpeed >= 0.20 and not IgnoreRollingResistance then
					-- Force variables for wheel
					local RollingForceX = 0.0;
					local RollingForceY = 0.0;
					local RollingForceZ = 0.0;
					-- Rolling resistance in rolling direction
					local RollingResistanceForceFactor = 0.4;
					local RollingForceToAdd = ActWheelRollForce*RollingResistanceForceFactor;
					-- Add force slowly in low speed
					if wheel.RollingDirectionSpeed < 1 then
						RollingForceToAdd = (RollingForceToAdd)*wheel.RollingDirectionSpeed;
					end;
					-- Add force in the other direction fo the moving direction
					RollingForceX, RollingForceY, RollingForceZ = localDirectionToWorld(wheel.driveNode, 0,0,-(wheel.RollingMovingDirection*RollingForceToAdd));						
					-- Add the calculated force to physics
					addForce (wheel.node, RollingForceX, RollingForceY, RollingForceZ, WheelX, WheelY, WheelZ, true);
				end;
				------------------------------------------------------
				-- If the wheel is moving in sideway direction add force
				if wheel.SideWaySpeed >= 0.2 then
					-- Force variables for wheel
					local SidewayForceX = 0.0;
					local SidewayForceY = 0.0;
					local SidewayForceZ = 0.0;
					-- Sideway resistance
					local SidewayResistanceForceFactor = 1.0;
					local SidewayForceToAdd = ActWheelRollForce*SidewayResistanceForceFactor;
					-- Add force slowly in low speed
					if wheel.SideWaySpeed < 1 then
						SidewayForceToAdd = SidewayForceToAdd*wheel.SideWaySpeed;
					end;
					-- Add force in the other direction fo the moving direction
					SidewayForceX, SidewayForceY, SidewayForceZ = localDirectionToWorld(wheel.driveNode, -(wheel.SideWayMovingDirection*SidewayForceToAdd),0,0);
					-- Add the calculated force to physics
					addForce (wheel.node, SidewayForceX, SidewayForceY, SidewayForceZ, WheelX, WheelY, WheelZ, true);
				end;
			end;
		end;
	end;
end;

-----------------------------------------------------------------------------------	
-- Creation and functions of gearbox 
-----------------------------------------------------------------------------------
function REA:REAupdateGear(acceleratorPedal, dt)

	--------------------------------------------------------------------
	-- Init data
	if self.GearChangeTimer == nil then
		self.GearChangeTimer = 0;
		self.GearChangeTime = 0;
		self.DelayNewGearAllowed = 0;
		self.TimeDelayNewGear = 250;
		self.ClutchEngageTime = 0;
		self.ClutchEngagePercentage = 0;
		self.maxClutchTorque = 0;
		self.differentialRpmSmoothed = 0;
	end;
	if self.AutoGearChangeTimer == nil then
		self.AutoGearChangeTimer = 0;
		self.AutoGearChangeTime = 0;
	end;
	if self.targetGear == nil then
		self.targetGear = 0;
	end;
	if self.previousGear == nil then
		self.previousGear = 0;
	end;
	if self.minGearRatio == nil then
		self.minGearRatio = 100;
	end;
	if self.maxGearRatio == nil then
		self.maxGearRatio = 100;
	end;
	if self.ChangeGear == nil then
		self.ChangeGear = false;
	end;
	if self.ImplementIsWorking == nil then
		self.ImplementIsWorking = false;
	end;
	if self.motorAppliedTorqueSmoothed == nil then
		self.motorAppliedTorqueSmoothed = 0;
		self.motorMaxTourqeRPM = 0;
		self.motorMaxTourqe = 0;
	end;

	--------------------------------------------------------------------
	-- Get applied tourqe
	self.motorAppliedTorqueSmoothed = REA:SmootheValue(self.motorAppliedTorqueSmoothed,self.motorAppliedTorque);
	local MotorAppliedTourqe = self.motorAppliedTorqueSmoothed;
	-- Actual load and rpm in percentage
	local MotorLoadPercentage = (MotorAppliedTourqe / math.max(self:getMotorAvailableTorque(), 0.0001))*100;
	-- Actual power applied
 	local MotorAppliedPower = MotorAppliedTourqe * self:getEqualizedMotorRpm() *math.pi/30;
	-- Does the motor have any external power need
	local MotorExternalPowerNeed = false;
	if self.motorExternalTorque > 0 or self.ImplementIsWorking then
		MotorExternalPowerNeed = true;
	end;

	--------------------------------------------------------------------
	-- Min och Max rpm
	local minRpm = self.minRpm;
	local maxRpm = self.maxRpm;
	local maxRpmLimited = math.min(PowerConsumer.getMaxPtoRpm(self.vehicle)*self.ptoMotorRpmRatio, self.maxRpm);
	local maxRpmLimitedByPTO = false;
	-- Use limited if not zero and lower then max to calculate gear max speed
	if maxRpmLimited > 0 then
		if maxRpmLimited < maxRpm then
			-- Use the lower rpm limit
			-- Max Rpm limited by PTO
			maxRpmLimitedByPTO = true;
		else
			-- Use max rpm as limited
			maxRpmLimited = maxRpm;
		end;
	else
		-- Use max rpm as limited
		maxRpmLimited = maxRpm;
	end;

	--------------------------------------------------------------------
	-- Make gearratios, determine time to change gear and get max tourqe
	if self.GearboxCreated == nil then
		-- Print data
		print("----------------------")
		print("Gearbox created by REA")
		--
		local MaxForwardSpeed = (self.maxForwardSpeed*3.6);
		local MaxBackwardSpeed = (self.maxBackwardSpeed*3.6);
		-- Print data
		print("Forward:")
		local forwardGearRatios = REA:CreateRatioTable(MaxForwardSpeed,minRpm,maxRpm,325,false);
		-- Print data
		print("Backward:")
		local backwardGearRatios = REA:CreateRatioTable(MaxBackwardSpeed,minRpm,maxRpm,325,true);
		-- Save gear ratios
		self.gearRatiosForward = forwardGearRatios;
		self.gearRatiosBackward = backwardGearRatios;
		self.gearChangeTime = 225-(self.peakMotorPower/10);
		if self.gearChangeTime < 100 then
			self.gearChangeTime = 100;
		end;
		self.ClutchEngageTime = 200;
		-- Print data
		print("Time to change gear:" .. self.gearChangeTime)
		print("Time to engage clutch:" .. self.ClutchEngageTime)
		-- Get max tourqe Rpm
		self.motorMaxTourqe = 0;
		for RPM=minRpm, maxRpm do
			local Tourqe = self:getTorqueCurveValue(RPM)
			if Tourqe > self.motorMaxTourqe then
				self.motorMaxTourqeRPM = RPM;
				self.motorMaxTourqe = Tourqe;
			end;
		end;
		print("Max tourqe RPM:" .. self.motorMaxTourqeRPM)
		print("Max tourqe:" .. self.motorMaxTourqe)
		print("----------------------")
		--
		self.GearboxCreated = true;
	end;

	--------------------------------------------------------------------
	-- Determine if moving forward or backward
	-- Get accelrator position
    local adjAcceleratorPedal = acceleratorPedal;
	local Forward = false;
	local Backward = false;
	local GearSign = 0;
	if adjAcceleratorPedal > 0 then
		Forward = true;
		GearSign = 1;
	elseif adjAcceleratorPedal < 0 then
		Backward = true;
		GearSign = -1;
	end
	-- Calculate differential RPM with smoothening
	self.differentialRpmSmoothed = REA:SmootheValue(self.differentialRpmSmoothed,math.abs(self.differentialRotSpeed * 30 / math.pi));
	local differentialRpm = self.differentialRpmSmoothed;

	--------------------------------------------------------------------
	-- Current gear
	local gearRatios = {1};
	local CurrentGearMinSpeed = 0;
	local CurrentGearMaxSpeed = 0;
	local CurrentGearSpeed = 0;
	local CurrentGearRatio = 0;
	local MotorAppliedTourqePerRatio = 0;
	local MotorAppliedPowerPerRatio = 0;
	local MaxTourqePerRatioOnCurrentGear = 0;
	local SpeedOfCurrentGearPercentage = 0;
	local CurrentGearClutchRpm = 0;
	-- Gearratio forward or backward
	if self.GearForward then
		gearRatios = self.gearRatiosForward;
	elseif self.GearBackward then
		gearRatios = self.gearRatiosBackward;
	end;
	-- Number of gears
	local NumberOfGears = table.getn(gearRatios);
	local CurrentGear = self.previousGear;
	if CurrentGear > 0 and gearRatios[CurrentGear] ~= nil then
		CurrentGearRatio = math.abs(gearRatios[CurrentGear]);
		CurrentGearClutchRpm = differentialRpm * CurrentGearRatio;
		-- Calculate min and max speed for current gear
		CurrentGearMinSpeed = minRpm / CurrentGearRatio / 2.653;
		CurrentGearMaxSpeed = maxRpmLimited / CurrentGearRatio / 2.653;
		CurrentGearSpeed = CurrentGearClutchRpm / CurrentGearRatio / 2.653;
		-- Calculate current speed in percentage
		SpeedOfCurrentGearPercentage = ((CurrentGearSpeed-CurrentGearMinSpeed) / (CurrentGearMaxSpeed-CurrentGearMinSpeed)) * 100;
		-- Calculate tourqe applied per gear ratio
		MotorAppliedTourqePerRatio = MotorAppliedTourqe * CurrentGearRatio;
		-- Calculate power applied per gear ratio
		MotorAppliedPowerPerRatio = (MotorAppliedTourqe * self:getEqualizedMotorRpm() *math.pi/30) * CurrentGearRatio;
		-- Calculate max avalible tourqe per gear ratio
		MaxTourqePerRatioOnCurrentGear = self.motorMaxTourqe * CurrentGearRatio;
	end;

	--------------------------------------------------------------------
	-- Lower gear
	local LowerGearPossible = false;
	local PredictedLowerGearClutchRpm = 0;
	-- If current gear not first gear read lower gear data
	if CurrentGear > 1 and gearRatios[CurrentGear] ~= nil then
		local LowerGear = CurrentGear-1;
		local LowerGearRatio = math.abs(gearRatios[LowerGear]);
		local LowerGearClutchRpm = differentialRpm * LowerGearRatio;
		PredictedLowerGearClutchRpm = LowerGearClutchRpm;
		-- Determine if lower gear is possible
		if LowerGearClutchRpm < maxRpm then
			LowerGearPossible = true;
		end;
	end;

	--------------------------------------------------------------------
	-- Higher gear
	local HigherGearPossible = false;
	local HigherGearClutchRpm = 0;
	local HigherGearPowerNeedPercentage = 0;
	local HigherGearTourqePerRatio = 0;
	local HigherGearPowerPerRatio = 0;
	local TotalMass = 0;
	local GearChangeSpeedChange = 0;
	local PredictedHigherGearClutchRpm = 0;
	-- If current gear not highest gear read higher gear data
	if CurrentGear < NumberOfGears and gearRatios[CurrentGear] ~= nil then
		local HigherGear = CurrentGear+1;
		local HigherGearRatio = math.abs(gearRatios[HigherGear]);
		HigherGearClutchRpm = differentialRpm * HigherGearRatio;
		-- Get total mass of all vehicle
		TotalMass = self.vehicle:getTotalMass();
		-- Calculate decelration (ACC = N / KG)
		local Acc = ((((MotorAppliedTourqe - self.motorExternalTorque) * CurrentGearRatio)*1000) / (TotalMass*1000)) * 3.6;
		-- Total time without power from engine
		local TotalGearchangeTime = self.gearChangeTime + (self.ClutchEngageTime / 2);
		-- Calculate loss off speed caused by gearchange
		GearChangeSpeedChange = Acc * (TotalGearchangeTime / 1000);
		-- Calculate RPM differance after gearchange
		local RPMDiffAfterHigherGear = (GearChangeSpeedChange * 2.653) * HigherGearRatio;
		-- Adjust predicted RPM depening on gear
		if CurrentGear == 1 or (NumberOfGears > 1 and CurrentGear == 2) then
			PredictedHigherGearClutchRpm = HigherGearClutchRpm;
		else
			PredictedHigherGearClutchRpm = HigherGearClutchRpm - RPMDiffAfterHigherGear;
		end;
		-- Get tourqe avalible on higher gear
		local HigherGearAvalibleTourqe = self:getTorqueCurveValue(PredictedHigherGearClutchRpm);
		-- Calculate tourqe avalible per gear ratio
		HigherGearTourqePerRatio = HigherGearAvalibleTourqe * HigherGearRatio;
		-- Calculate power avalible per gear ratio
		HigherGearPowerPerRatio = (HigherGearAvalibleTourqe * self:getEqualizedMotorRpm() *math.pi/30) * HigherGearRatio;
		-- Determine if higher gear is possible
		if PredictedHigherGearClutchRpm > minRpm then
			HigherGearPossible = true;
		end;
	end;

	--------------------------------------------------------------------
	local NewGearAllowed = false;
	-- Allow new gearchange
	if self.ChangeGear == false and self.ClutchEngagePercentage == 100 then
		-- Delay time to change gear
		if self.DelayNewGearAllowed > self.TimeDelayNewGear then
			NewGearAllowed = true;
		else
			self.DelayNewGearAllowed = self.DelayNewGearAllowed + dt;
		end;
	else
		self.DelayNewGearAllowed = 0;
	end;

	--------------------------------------------------------------------
	-- Determine if gearchange should be done
	local ShiftToForward = false;
	local ShiftToBackward = false;
	local ShiftToLowerGear = false;
	local ShiftToHigherGear = false;
	if NewGearAllowed then
		--------------------------
		-- Shift to forward
		if Forward then
			if CurrentGear == 0 or self.GearBackward then
				ShiftToForward = true;
				self.AutoGearChangeTime = 200;
			end;
		end;
		-- Shift to backward
		if Backward then
			if CurrentGear == 0 or self.GearForward then
				ShiftToBackward = true;
				self.AutoGearChangeTime = 200;
			end;
		end;
		----------------------------------------------------
		-- Shift up or down possible if not changeing direction
		if not ShiftToForward and not ShiftToBackward then
			-- lower gear
			if LowerGearPossible then
				if MotorLoadPercentage > 90 and CurrentGearClutchRpm < self.motorMaxTourqeRPM then
					ShiftToLowerGear = true;
					self.AutoGearChangeTime = 200;
				end;
				if CurrentGearClutchRpm < self.motorMaxTourqeRPM and ((not Forward and self.GearForward) or (not Backward and self.GearBackward)) then
					ShiftToLowerGear = true;
					self.AutoGearChangeTime = 200;
				end;
 			end;
			-- Higher gear
			if HigherGearPossible then
				if Forward or Backward then
					if not MotorExternalPowerNeed and HigherGearPowerPerRatio > MotorAppliedPowerPerRatio then
						ShiftToHigherGear = true;
						self.AutoGearChangeTime = 250;
					elseif MotorExternalPowerNeed and HigherGearPowerPerRatio > (MotorAppliedPowerPerRatio * 1.15) then
						ShiftToHigherGear = true;
						self.AutoGearChangeTime = 350;
					elseif CurrentGear == 1 and HigherGearPowerPerRatio > (MotorAppliedPowerPerRatio * 0.40) then
						ShiftToHigherGear = true;
						self.AutoGearChangeTime = 1000;
					elseif CurrentGear == 2 and HigherGearPowerPerRatio > (MotorAppliedPowerPerRatio * 0.75) then
						ShiftToHigherGear = true;
						self.AutoGearChangeTime = 1000;
					end;
				end;
			end;
		end;
	end;

	--------------------------------------------------------------------
	-- If new gear wanted wait until timer runs out
	local ChangeGear = false;
	if ShiftToLowerGear or ShiftToHigherGear or ShiftToForward or ShiftToBackward then
		-- Run timer
		self.AutoGearChangeTimer = self.AutoGearChangeTimer+dt;
		-- When time elapsed change gear
		if self.AutoGearChangeTimer > self.AutoGearChangeTime	then
			ChangeGear = true;
		end;
	else
		self.AutoGearChangeTimer = 0;
	end;

	--------------------------------------------------------------------
	-- Change gear, set new target gear
	if ChangeGear then
		if ShiftToLowerGear then
			self.targetGear = CurrentGear-1;
			self.TimeDelayNewGear = 0;
		elseif ShiftToHigherGear then
			self.targetGear = CurrentGear+1;
			self.TimeDelayNewGear = 500;
		elseif ShiftToForward then
			gearRatios = self.gearRatiosForward;
			self.GearForward = true;
			self.GearBackward = false;
			self.targetGear = 1;
			self.TimeDelayNewGear = 250;
		elseif  ShiftToBackward then
			gearRatios = self.gearRatiosBackward;
			self.GearBackward = true;
			self.GearForward = false;
			self.targetGear = 1;
			self.TimeDelayNewGear = 250;
		end;
		self.ChangeGear = true;
		self.AutoGearChangeTimer = 0;
	end;

	--------------------------------------------------------------------
	-- Change gear ratio after time elapsed
	if self.ChangeGear then
		-- Gearchange is happening
		self.minGearRatio = 0;
		self.maxGearRatio = 0;
		adjAcceleratorPedal = 0;
		self.maxClutchTorque = 0;
		self.ClutchEngagePercentage = 0;
		-- Count down time for gearchange
		self.gearChangeTimer = self.gearChangeTimer+dt;
		-- When time elapsed change gear
		if self.gearChangeTimer > self.gearChangeTime then
			-- Save gear
			self.previousGear = self.targetGear;
			-- Gear ratio for selected gear
			self.minGearRatio = gearRatios[self.previousGear];
			self.maxGearRatio = self.minGearRatio;
			-- Gearchange finished
			self.ChangeGear = false;
		end;
	else
		-- Restart timer gearchange timer
		self.gearChangeTimer = 0;
		-- If not clutch 100% engaged engade clutch
		if self.ClutchEngagePercentage ~= 100 then
			-- Engagage clutch
			self.ClutchEngagePercentage = self.ClutchEngagePercentage + ((dt/self.ClutchEngageTime)*100);
			-- Clutch engagepercentage
			self.maxClutchTorque = self.torqueCurve:getMaximum() * (self.ClutchEngagePercentage/100);
			-- If clutch 100% engaged set max tourqe
			if self.ClutchEngagePercentage > 100 then
				self.maxClutchTorque = 5;
				self.ClutchEngagePercentage = 100
			end;
		end;
	end;
	-- Save current gear to avoid automatic braking
	self.gear = self.previousGear;

	-- If wrong gear ratio adjust accelrator
	if Forward and self.maxGearRatio < 0 then
		adjAcceleratorPedal = 0;
	end;
	if Backward and self.maxGearRatio > 0 then
		adjAcceleratorPedal = 0;
	end;

	-- DEBUG
	--renderText(0.2, 0.07, 0.02,"Applied tourqe: " .. MotorAppliedTourqe);
	--renderText(0.2, 0.10, 0.02,"Max avalible tourqe: " .. MaxTourqePerRatioOnCurrentGear);
	--renderText(0.2, 0.13, 0.02,"Applied tourqe per ratio: " .. MotorAppliedTourqePerRatio);
	--renderText(0.2, 0.16, 0.02,"Higher gear tourqe per ratio: " .. HigherGearTourqePerRatio);
	--renderText(0.2, 0.22, 0.02,"Max tourqe RPM: " .. self.motorMaxTourqeRPM);
	--renderText(0.2, 0.25, 0.02,"Current gear: " .. self.gear);
	--renderText(0.2, 0.28, 0.02,"Total mass: " .. TotalMass);
	--renderText(0.2, 0.31, 0.02,"Speed differance: " .. GearChangeSpeedChange);
	--renderText(0.2, 0.34, 0.02,"Used power per ratio: " .. MotorAppliedPowerPerRatio);
	--renderText(0.2, 0.37, 0.02,"Higher gear power per ratio: " .. HigherGearPowerPerRatio);
	--renderText(0.2, 0.40, 0.02,"Accelration: " .. self.Acc);
	--renderText(0.2, 0.43, 0.02,"Acc speed: " .. self.AccSpeed);

    return adjAcceleratorPedal
end

-----------------------------------------------------------------------------------	
-- Function to create table for ratios based on speed
-----------------------------------------------------------------------------------
function REA:CreateRatioTable(MaxSpeed,minRpm,maxRpm,RatioDivider,NegateRatio)

	-----------------------------
	-- Create ratio table
	local RatioTable = {1};
	-- Calculate speedstep each gear
	local SpeedStepEachGear = (maxRpm-minRpm)/RatioDivider;
	-- Calculate number of gears
	local NumberOfGears = REA:RoundValue(MaxSpeed / SpeedStepEachGear);
	-- Create table
	if NumberOfGears == 1 then
		RatioTable = {1};
	elseif NumberOfGears == 2 then
		RatioTable = {1,1};
	elseif NumberOfGears == 3 then
		RatioTable = {1,1,1};
	elseif NumberOfGears == 4 then
		RatioTable = {1,1,1,1};
	elseif NumberOfGears == 5 then
		RatioTable = {1,1,1,1,1};
	elseif NumberOfGears == 6 then
		RatioTable = {1,1,1,1,1,1};
	elseif NumberOfGears == 7 then
		RatioTable = {1,1,1,1,1,1,1};
	elseif NumberOfGears == 8 then
		RatioTable = {1,1,1,1,1,1,1,1};
	elseif NumberOfGears == 9 then
		RatioTable = {1,1,1,1,1,1,1,1,1};
	elseif NumberOfGears == 10 then
		RatioTable = {1,1,1,1,1,1,1,1,1,1};
	elseif NumberOfGears == 11 then
		RatioTable = {1,1,1,1,1,1,1,1,1,1,1};
	elseif NumberOfGears == 12 then
		RatioTable = {1,1,1,1,1,1,1,1,1,1,1,1};
	elseif NumberOfGears == 13 then
		RatioTable = {1,1,1,1,1,1,1,1,1,1,1,1,1};
	elseif NumberOfGears == 14 then
		RatioTable = {1,1,1,1,1,1,1,1,1,1,1,1,1,1};
	elseif NumberOfGears == 15 then
		RatioTable = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
	else
		RatioTable = {1,1,1,1,1,1,1,1,1,1};
	end;

	-----------------------------
	-- Create gear ratios
	-- Actual number of gears
	NumberOfGears = table.getn(RatioTable);
	print("Number of gears: " .. NumberOfGears)
	--
	local BaseSpeedStepPart = 0.8;
	local AddSpeedStepPart = 1-BaseSpeedStepPart;
	local BaseSpeedStep = (MaxSpeed*BaseSpeedStepPart) / NumberOfGears;
	local AddSpeedStep = (MaxSpeed*AddSpeedStepPart) / NumberOfGears;
	local AddSpeed = 0;
	for GearNumber=1, NumberOfGears do
		local CurrentGearMaxSpeed = 0;
		-- If more then 2 gears add more speed on higher gears
		if GearNumber > 2 then
			AddSpeed = (GearNumber*AddSpeedStep)*(GearNumber/NumberOfGears);
		end;
		if GearNumber == 1 and NumberOfGears > 2 then
			AddSpeed = 1;
		end;
		-- Calculate max speed for current gear
		CurrentGearMaxSpeed = (BaseSpeedStep*GearNumber)+AddSpeed;
		-- Calculate gear ratio
		RatioTable[GearNumber] = maxRpm / CurrentGearMaxSpeed / 2.653;
		-- Negate ratio
		if NegateRatio == true then
			RatioTable[GearNumber] = RatioTable[GearNumber]*(-1);
		end;
		-- Print data for current gear
		print("Gear: " .. GearNumber .. ", Ratio: " .. REA:RoundValue(RatioTable[GearNumber]) .. ", Max speed: " .. REA:RoundValue(CurrentGearMaxSpeed))
		--
	end;

	-- Return ratio table
	return RatioTable;
end

-----------------------------------------------------------------------------------	
-- Function to determine which tireType based on tireTrackAtlasIndex
-----------------------------------------------------------------------------------
function REA:DetermineTireType(tireTrackAtlasIndex)
	-- Constants to use for each tireTypeName
	local TireTypeMUD = "mud";
	local TireTypeOFFROAD = "offRoad";
	local TireTypeSTREET = "street";
	local TireTypeCRAWLER = "crawler";
	-- Value to return
	local tireTypeName = TireTypeMUD;
	-- Check tiretrackindex to see if value present
	if tireTrackAtlasIndex ~= nil then
		-- Check number to determine which tiretypename
		if tireTrackAtlasIndex == 0 then
			tireTypeName = TireTypeMUD;
		elseif tireTrackAtlasIndex == 1 then
			tireTypeName = TireTypeSTREET;
		elseif tireTrackAtlasIndex == 2 then
			tireTypeName = TireTypeOFFROAD;
		elseif tireTrackAtlasIndex == 3 then
			tireTypeName = TireTypeOFFROAD;
		elseif tireTrackAtlasIndex == 4 then
			tireTypeName = TireTypeSTREET;
		elseif tireTrackAtlasIndex == 5 then
			tireTypeName = TireTypeCRAWLER;
		elseif tireTrackAtlasIndex == 6 then
			tireTypeName = TireTypeCRAWLER;
		elseif tireTrackAtlasIndex == 7 then
			tireTypeName = TireTypeCRAWLER;
		elseif tireTrackAtlasIndex == 8 then
			tireTypeName = TireTypeSTREET;
		elseif tireTrackAtlasIndex == 9 then
			tireTypeName = TireTypeMUD;
		elseif tireTrackAtlasIndex == 10 then
			tireTypeName = TireTypeOFFROAD;
		elseif tireTrackAtlasIndex == 11 then
			tireTypeName = TireTypeOFFROAD;
		elseif tireTrackAtlasIndex == 12 then
			tireTypeName = TireTypeOFFROAD;
		elseif tireTrackAtlasIndex == 13 then
			tireTypeName = TireTypeCRAWLER;
		elseif tireTrackAtlasIndex == 14 then
			-- Not used
			tireTypeName = TireTypeMUD;
		elseif tireTrackAtlasIndex == 15 then
			-- Not used
			tireTypeName = TireTypeMUD;
		else
			tireTypeName = TireTypeMUD;
		end
	end	
	-- Return tireType
	return WheelsUtil.getTireType(tireTypeName);
end


-----------------------------------------------------------------------------------	
-- Function to determine if vehicle have a implement that is working
-----------------------------------------------------------------------------------
function REA:GetImplementWorking(vehicle)
	local IsWorking = false;
	-- Is the veicle working
	IsWorking = vehicle:doCheckSpeedLimit();
	-- If the vehicle is not working check if implement is working
	if not IsWorking then
		if vehicle.getAttachedImplements ~= nil then
			local attachedImplements = vehicle:getAttachedImplements();
			for _, implement in pairs(attachedImplements) do
				if implement.object ~= nil then
					IsWorking = implement.object:doCheckSpeedLimit();
					if IsWorking then
						break;
					end;
				end;
			end;
		end;
	end;
	-- Return result
	return IsWorking;
end


-----------------------------------------------------------------------------------	
-- Function to round value, delete decimals
-----------------------------------------------------------------------------------
function REA:RoundValue(x)
	return x>=0 and math.floor(x+0.5) or math.ceil(x-0.5)
end


-----------------------------------------------------------------------------------	
-- Function to smoothe value
-----------------------------------------------------------------------------------
function REA:SmootheValue(SmoothedValue,RealValue)
	-- If no smoothevalue use the real value
	if SmoothedValue == nil then
		ActValue = RealValue;
	else
		ActValue = SmoothedValue;
	end;
	-- Return the smoothed value
	return (ActValue*0.9)+(RealValue*0.1);
end


-----------------------------------------------------------------------------------	
-- Function to set new value during set time
-----------------------------------------------------------------------------------
function REA:SetValueWithTime(ActValue,TargetValue,OriginalValue,Time,dt)
	-- If values nil return zero
	if ActValue == nil or TargetValue == nil then
		return 0;
	end;
	-- If differens change value over time
	if ActValue ~= TargetValue then
		-- If difference betweene original value and target value calculate differens
		local DiffValue = TargetValue - OriginalValue;
		-- Calculate how much is target should change
		local NewValue = ActValue + (DiffValue * (dt / Time));
		-- Check if new value is outside target area
		if NewValue > TargetValue and TargetValue > OriginalValue then
			NewValue = TargetValue;
		elseif NewValue < TargetValue and TargetValue < OriginalValue then
			NewValue = TargetValue;
		end;
		-- Return new value
		return NewValue;
	else
		-- If no differens return Target value
		return TargetValue;
	end;
end


-----------------------------------------------------------------------------------	
-- Function to calculate filling speed in thousend liters per second
-----------------------------------------------------------------------------------
function REA:CalcFillSpeed(LastFillLevel,NewFillLevel,dt)
	-- Initialize liters per second
	local ThousendLiterPerSecond  = 0;
	-- If Fill level changed calculate fill speed
	if NewFillLevel > LastFillLevel then
		-- Calculate fill speed
		ThousendLiterPerSecond = ((NewFillLevel - LastFillLevel) / 1000) / (dt / 1000);
	end;
	-- Return last fill level and liter per seconds
	return NewFillLevel, ThousendLiterPerSecond;
end


-----------------------------------------------------------------------------------	
-- Calculate sideway speed of wheel
-----------------------------------------------------------------------------------
function REA:UpdateWheelDirectionAndSpeed(wheel,dt)
	local speedReal = 0;
	local movedDistance = 0;
	local MovingDirection = 0;

	-- Calculate speed based on the position change
	local x,y,z = getWorldTranslation(wheel.driveNode);
	if wheel.REALastPosition == nil then
		wheel.REALastPosition = {x,y,z};
	end;
	local dx, dy, dz = worldDirectionToLocal(wheel.driveNode, x-wheel.REALastPosition[1], y-wheel.REALastPosition[2], z-wheel.REALastPosition[3]);
	wheel.REALastPosition[1], wheel.REALastPosition[2], wheel.REALastPosition[3] = x, y, z;

	-- Rolling direction
	speedReal = 0;
	movedDistance = 0;
	MovingDirection = 0;
	-- Moving direction
	if dz > 0.001 then
		MovingDirection = 1;
	elseif dz < -0.001 then
		MovingDirection = -1;
	end;
	-- Calculate speed of wheel in direction
	movedDistance = dz;
	speedReal = (movedDistance / dt)*3600;
	-- Remove sign
	if speedReal < 0 then
		speedReal = speedReal*(-1); 
	end;
	-- Save result to wheel
	wheel.RollingDirectionSpeed = REA:SmootheValue(wheel.RollingDirectionSpeed,speedReal);
	wheel.RollingMovingDirection = MovingDirection;

	-- SideWay direction
	speedReal = 0;
	movedDistance = 0;
	MovingDirection = 0;
	-- Moving direction
	if dx > 0.001 then
		MovingDirection = 1;
	elseif dx < -0.001 then
		MovingDirection = -1;
	end;
	-- Calculate speed of wheel in direction
	movedDistance = dx;
	speedReal = (movedDistance / dt)*3600;
	-- Remove sign
	if speedReal < 0 then
		speedReal = speedReal*(-1); 
	end;
	-- Save result to wheel
	wheel.SideWaySpeed = REA:SmootheValue(wheel.SideWaySpeed,speedReal);
	wheel.SideWayMovingDirection = MovingDirection;
end;


-----------------------------------------------------------------------------------	
-- Function for adjusting speed if PTO tourqe reaches max motor tourqe
-----------------------------------------------------------------------------------
function REA:AdjustSpeedIfPtpPowerMaxed(vehicle,dt)
	local motor = vehicle.spec_motorized.motor;

	-- Calculate avalible power
	local PowerAvalible = motor.motorAvailableTorque * motor.lastMotorRpm *math.pi/30
	-- Lowest speed setpoint
	local LowSpeedSetpoint = 3;
	-- Get speedlimit of motor
	local SpeedLimit = 1000;
	if motor.speedLimit ~= nil then
		if motor.speedLimit < SpeedLimit then
			SpeedLimit = motor.speedLimit;
		end;
	end;
	-- Get total power need by filling from all implements
	local TotalPowerNeedByFilling = 0;
	local HighestPowerNeed = 0;
	local attachedImplements;
	if vehicle.getAttachedImplements ~= nil then
		attachedImplements = vehicle:getAttachedImplements();
		for _, implement in pairs(attachedImplements) do
			if implement.object ~= nil then
				if implement.object.spec_powerConsumer ~= nil then
					-- Save to local power consumer
					local PowerConsumer = implement.object.spec_powerConsumer;
					-- If power is consumed by implement add power to total amount consumed by all implements
					if PowerConsumer.PowerToAddPTOSmoothed ~= nil then
						-- Initialize original speed limit of implement
						if PowerConsumer.OriginalSpeedlimit == nil then
							PowerConsumer.OriginalSpeedlimit = implement.object.speedLimit;
							PowerConsumer.CurrentSpeedLimit = PowerConsumer.OriginalSpeedlimit;
							PowerConsumer.SpeedRegulatorTimer = 0;
						end;
						-- Speedlimit of implement
						if implement.object:doCheckSpeedLimit() then
							-- Power consumed by filling
							TotalPowerNeedByFilling = PowerConsumer.PowerToAddPTOSmoothed + TotalPowerNeedByFilling;
							-- Save highest power need and speedlimit to know which implemnt to use as speedlimiter
							if PowerConsumer.PowerToAddPTOSmoothed > HighestPowerNeed then
								HighestPowerNeed = PowerConsumer.PowerToAddPTOSmoothed;
								SpeedLimit = PowerConsumer.OriginalSpeedlimit;
							end;
						end;
					end;
				end;
			end;
		end;
		-- Adjust speed depending on power need
		for _, implement in pairs(attachedImplements) do
			if implement.object ~= nil then
				if implement.object.spec_powerConsumer ~= nil then
					-- Save to local power consumer
					local PowerConsumer = implement.object.spec_powerConsumer;
					if PowerConsumer.PowerToAddPTOSmoothed ~= nil then
						-- If implement uses power from filling check if power needed and is the most consuming adjust speedlimit
						if PowerConsumer.PowerToAddPTOSmoothed == HighestPowerNeed and HighestPowerNeed ~= 0 then
							-- Regulator for adjusting speed depending on poweruse by filling
							PowerConsumer.CurrentSpeedLimit,PowerConsumer.SpeedRegulatorTimer = REA:SpeedPowerRegulator(TotalPowerNeedByFilling,PowerAvalible*0.9,LowSpeedSetpoint,SpeedLimit,PowerConsumer.CurrentSpeedLimit,PowerConsumer.SpeedRegulatorTimer,dt);
							-- Add speed limit to implement
							implement.object.speedLimit = PowerConsumer.CurrentSpeedLimit;
						-- Implement is not the one consuming the most set original speedlimt
						else
							implement.object.speedLimit = PowerConsumer.OriginalSpeedlimit;
						end;
					end;
				end;
			end;
		end;
	end;
end;


-----------------------------------------------------------------------------------	
-- Update power multiplier for power consumers
-----------------------------------------------------------------------------------
function REA:UpdatePowerMultiplier(vehicle,dt)
	---------------------------------------------------------------------
	-- Check if this is a Plow, cultivator or sowingmachine
	local Plow = false;
	local Cultivator = false;
	local SowingMachine = false;
	local Combine = false;
	local Baler = false;
	local ForageWagon = false;
	-- Plow
	if vehicle.spec_plow ~= nil then
		Plow = true;
	-- Cultivator
	elseif vehicle.spec_cultivator ~= nil then
		Cultivator = true;
	-- Sowing machine
	elseif vehicle.spec_sowingMachine ~= nil then
		SowingMachine = true;
	-- Combine
	elseif vehicle.spec_combine ~= nil then
		Combine = true;
	-- Baler
	elseif vehicle.spec_baler ~= nil then
		Baler = true;
	-- Forage wagon
	elseif vehicle.spec_forageWagon ~= nil then
		ForageWagon = true;
	end;
	-- Adjust force and speed for plows, Cultivators and sowing machines
	if vehicle.spec_powerConsumer ~= nil and ( Plow or Cultivator or SowingMachine ) then
		local PowerConsumer = vehicle.spec_powerConsumer;
		if PowerConsumer.forceNode ~= nil then
			-- Save original max force
			if PowerConsumer.OriginalMaxForce == nil then
				PowerConsumer.OriginalMaxForce = PowerConsumer.maxForce;
			end;
			-- Calculate multiplier depending on type of implement and ground type
			local TargetMaxForce = PowerConsumer.OriginalMaxForce;
			-- Do not ignore rolling resistance of wheels
			PowerConsumer.IgnoreRollingResistance = true;
			if vehicle:doCheckSpeedLimit() then
				-- Get density att "ForceNode"
				local SizeOfDenityArea = 0.5;
				local SizeOffset = SizeOfDenityArea/2;
				local x0,_,z0 = localToWorld(PowerConsumer.forceNode, SizeOffset, 0, -SizeOffset);
				local x1,_,z1 = localToWorld(PowerConsumer.forceNode, -SizeOffset, 0, -SizeOffset);
				local x2,_,z2 = localToWorld(PowerConsumer.forceNode, SizeOffset, 0, SizeOffset);
				local density, area = FSDensityMapUtil.getFieldValue(x0, z0, x1, z1, x2, z2);
				-- Determine which groundtype it is
				local terrainValue = 0;
				if area > 0 then
					terrainValue = math.floor(density/area + 0.5);
				end;
				-- Determine type of implement and which multiplier to use
				-- Initialize multiplier
				local multiplier = 1;
				-- Plow
				if Plow then
					if REA.PlowMultiplier[terrainValue] ~= nil and REA.PlowSpeedAjust[terrainValue] ~= nil then
						multiplier = REA.PlowMultiplier[terrainValue];
					end;
				-- Cultivator
				elseif Cultivator then
					if REA.CultivatorMultiplier[terrainValue] ~= nil and REA.CultivatorSpeedAjust[terrainValue] ~= nil then
						multiplier = REA.CultivatorMultiplier[terrainValue];
					end;
				-- Sowing machine
				elseif SowingMachine then
					if REA.SowingMachineMultiplier[terrainValue] ~= nil and REA.SowingMachineSpeedAjust[terrainValue] ~= nil then
						multiplier = REA.SowingMachineMultiplier[terrainValue];				
					end;
				end;
				-- Adjust pulling max force
				TargetMaxForce = PowerConsumer.OriginalMaxForce * multiplier;
				-- Ignore Wheele roling resistance
				PowerConsumer.IgnoreRollingResistance = true;
			end;
			-- Save new values
			PowerConsumer.maxForce = REA:SmootheValue(PowerConsumer.maxForce,TargetMaxForce);
		end;
	end;

	---------------------------------------------------------------------
	-- Adjust force needed on PTO by filling a fillunit
	-- !COMBINE IS DISABLED AND UNDER DEVELOPMENT!
	if vehicle.spec_fillUnit ~= nil and ((vehicle.spec_powerConsumer ~= nil and (Baler or ForageWagon)) or (Combine and false)) then
		-- Save local copy of FillUnit
		local FillUnit = vehicle.spec_fillUnit;
		-- Get number of fillunits
		local numFillUnits = table.getn(FillUnit.fillUnits);
		-- Total fillspeed for all fillunits
		local TotalFillSpeed = 0;
		-- Search for correct fill unit and get current filllevel
		for FillUnitIndex=1, numFillUnits do
			local ActFillUnit = FillUnit.fillUnits[FillUnitIndex];
			if ActFillUnit.fillType ~= FillType.DIESEL and ActFillUnit.fillType ~= FillType.DEF then
				-- Create variables for calculating fill speed
				if ActFillUnit.TimeLastChange == nil then
					ActFillUnit.TimeLastChange = 0;
					ActFillUnit.LastFillLevel = 0;
					ActFillUnit.AddedFillLevel = 0;
					ActFillUnit.FillSpeedLS = 0;
					ActFillUnit.FillSpeedLSSmoothed = 0;
				end;
				-- Add time change since last fill, max 1 second
				if ActFillUnit.TimeLastChange < 1000 then
					ActFillUnit.TimeLastChange = ActFillUnit.TimeLastChange + dt;
				end;
				-- Calculate change in fill level
				ActFillUnit.AddedFillLevel = ActFillUnit.fillLevel - ActFillUnit.LastFillLevel;
				-- Save fill level
				ActFillUnit.LastFillLevel = ActFillUnit.fillLevel;
				-- If fillunit added fill since last update calculate fillspeed and reset value
				ActFillUnit.FillSpeedLS = 0;
				if ActFillUnit.AddedFillLevel > 0 then
					-- Calculate fillspeed Liter / second
					ActFillUnit.FillSpeedLS = ActFillUnit.AddedFillLevel / (ActFillUnit.TimeLastChange / 1000);
					ActFillUnit.TimeLastChange = 0;
					ActFillUnit.AddedFillLevel = 0;
				end;
				-- Smoothe fillspeed value
				ActFillUnit.FillSpeedLSSmoothed = REA:SmootheValue(ActFillUnit.FillSpeedLSSmoothed,ActFillUnit.FillSpeedLS);
				if ActFillUnit.FillSpeedLSSmoothed < 0.001 then
					ActFillUnit.FillSpeedLSSmoothed = 0;
				end;
				-- Calculate total fill speed
				TotalFillSpeed = TotalFillSpeed + ActFillUnit.FillSpeedLSSmoothed;
			end;
		end;

		-- DEBUG
		--renderText(0.2, 0.35, 0.05,"Num of fillunits: " .. tostring(numFillUnits));
		--renderText(0.2, 0.15, 0.05,"Fillspeed smoothed: " .. tostring(TotalFillSpeed));

		-- If combine use cutter as power consumer
		local CutterWorking = false;
		local PowerConsumer;
		if Combine then
			if vehicle.spec_combine.attachedCutters ~= nil then
				local cutters = vehicle.spec_combine.attachedCutters;
				for cutter, _ in pairs(cutters) do
					if cutter:doCheckSpeedLimit() and cutter.spec_powerConsumer ~= nil then
						PowerConsumer = cutter.spec_powerConsumer;
						CutterWorking = true;
					end;
				end;
			end;
		elseif vehicle.spec_powerConsumer ~= nil then
			PowerConsumer = vehicle.spec_powerConsumer;
		end;
		-- If vehicle is working add fillspeed power need
		if PowerConsumer ~= nil then
			-- Initiate variables
			if PowerConsumer.PowerToAddPTOSmoothed == nil then
				PowerConsumer.PowerToAddPTOSmoothed = 0;
			end;
			-- Save original values
			if PowerConsumer.OriginalNeededMinPtoPower == nil and PowerConsumer.neededMinPtoPower ~= nil then
				PowerConsumer.OriginalNeededMinPtoPower = PowerConsumer.neededMinPtoPower;
			end;
			if PowerConsumer.OriginalNeededMaxPtoPower == nil and PowerConsumer.neededMaxPtoPower ~= nil then
				PowerConsumer.OriginalNeededMaxPtoPower = PowerConsumer.neededMaxPtoPower;
			end;
			-- Add power to PTO if vehicle is working
			if vehicle:doCheckSpeedLimit() or (Combine and CutterWorking) then
				local FillspeedPowerNeed = 600;
				local PowerToAddPTO = 0;
				local PowerNeedByFilling = 0;
				-- If fillspeed present add power
				if TotalFillSpeed > 0.001 then
					-- Calculate power to be added to PTO based on filling speed
					PowerNeedByFilling = FillspeedPowerNeed * (TotalFillSpeed/100);
					-- Power to add PTO
					local PowerFactorForImplement = 0.5;
					if PowerConsumer.neededMinPtoPower ~= nil then
						if PowerNeedByFilling > (PowerConsumer.OriginalNeededMinPtoPower * PowerFactorForImplement) then
							PowerToAddPTO = PowerNeedByFilling - (PowerConsumer.OriginalNeededMinPtoPower * PowerFactorForImplement);
						end;
					end;
					if PowerConsumer.neededMaxPtoPower ~= nil then
						if PowerToAddPTO == 0 then
							if PowerNeedByFilling > (PowerConsumer.OriginalNeededMaxPtoPower * PowerFactorForImplement) then
								PowerToAddPTO = PowerNeedByFilling - (PowerConsumer.OriginalNeededMaxPtoPower * PowerFactorForImplement);
							end;
						end;
					end;
				end;
				-- Smoothe power to add
				PowerConsumer.PowerToAddPTOSmoothed = REA:SmootheValue(PowerConsumer.PowerToAddPTOSmoothed,PowerToAddPTO);
				-- If power to add is low set zero value
				if PowerConsumer.PowerToAddPTOSmoothed < 0.001 then
					PowerConsumer.PowerToAddPTOSmoothed = 0;
				end;
				-- Add power need
				if PowerConsumer.PowerToAddPTOSmoothed > 0 then
					if PowerConsumer.neededMinPtoPower ~= nil then
						PowerConsumer.neededMinPtoPower = PowerConsumer.OriginalNeededMinPtoPower + PowerConsumer.PowerToAddPTOSmoothed;
					end;
					if PowerConsumer.neededMaxPtoPower ~= nil then
						PowerConsumer.neededMaxPtoPower = PowerConsumer.OriginalNeededMaxPtoPower + PowerConsumer.PowerToAddPTOSmoothed;
					end;
				end;

				-- DEBUG
				--renderText(0.2, 0.20, 0.05,"Power need by filling: " .. tostring(PowerNeedByFilling));
				--renderText(0.2, 0.25, 0.05,"PTO Power to add: " .. tostring(PowerConsumer.PowerToAddPTOSmoothed));

			else
				-- No power needed
				PowerConsumer.PowerToAddPTOSmoothed = 0;
				-- Reset to original values
				if PowerConsumer.neededMinPtoPower ~= nil then
					PowerConsumer.neededMinPtoPower = PowerConsumer.OriginalNeededMinPtoPower;
				end;
				if PowerConsumer.neededMaxPtoPower ~= nil then
					PowerConsumer.neededMaxPtoPower = PowerConsumer.OriginalNeededMaxPtoPower;
				end;
			end;
		end;
	end;
end


-----------------------------------------------------------------------------------	
-- Update power multiplier for power consumers
-----------------------------------------------------------------------------------
function REA:SpeedPowerRegulator(Input,Setpoint,outputMin,outputMax,LastOutput,Timer,dt)
	local timeStep = 50
	-- Add time to timer
	Timer = Timer + dt
	-- Run regulator
	if Timer > timeStep then
		-- Restart intervall timer
		Timer = 0;
		-- Calculate error
		local err = Setpoint - Input;
		-- Calculate ajustment value
		local Adjust = 0;
		if err ~= 0 then
			Adjust = err / 100;
		end;
		-- Calculate new output value
		local output = Adjust + LastOutput;
		-- Check if output in bounds
		if output > outputMax then
			output = outputMax
		elseif output < outputMin then
			output = outputMin
		end
		-- Smoothe value
		LastOutput = REA:SmootheValue(LastOutput,output);
		-- Return new output
		return LastOutput, Timer;
	end;
	-- Return last output
	return LastOutput, Timer;
end;

-----------------------------------------------------------------------------------	
-- Edited loadWheelData
-----------------------------------------------------------------------------------
function Wheels:loadWheelData(wheel, xmlFile, configKey)
	local key = "nodeLeft"
	if not wheel.isLeft then
		key = "nodeRight"
	end
	
	wheel.radius = getXMLFloat(xmlFile, configKey..".physics#radius") or wheel.radius
	if wheel.radius == nil then
		g_logManager:xmlWarning(self.configFileName, "No radius defined for wheel '%s'! Using default value of 0.5!", configKey..".physics#radius")
		wheel.radius = 0.5
	end
	
	wheel.width = getXMLFloat(xmlFile, configKey..".physics#width") or wheel.width
	if wheel.width == nil then
		g_logManager:xmlWarning(self.configFileName, "No width defined for wheel '%s'! Using default value of 0.5!", configKey..".physics#width")
		wheel.width = 0.5
	end
	
	wheel.mass = getXMLFloat(xmlFile, configKey..".physics#mass") or wheel.mass or 0.1
	local tireTypeName = getXMLString(xmlFile, configKey..".tire#tireType")
	wheel.frictionScale = getXMLFloat(xmlFile, configKey..".physics#frictionScale") or wheel.frictionScale
	wheel.maxLongStiffness = getXMLFloat(xmlFile, configKey..".physics#maxLongStiffness") or wheel.maxLongStiffness -- [t / rad]
	wheel.maxLatStiffness = getXMLFloat(xmlFile, configKey..".physics#maxLatStiffness") or wheel.maxLatStiffness -- xml is ratio to restLoad [1/rad], final value is [t / rad]
	wheel.maxLatStiffnessLoad = getXMLFloat(xmlFile, configKey..".physics#maxLatStiffnessLoad") or wheel.maxLatStiffnessLoad -- xml is ratio to restLoad, final value is [t]
	wheel.tireTrackAtlasIndex = getXMLInt(xmlFile, configKey..".tire#tireTrackAtlasIndex") or wheel.tireTrackAtlasIndex or 0

	wheel.tireType = WheelsUtil.getTireType(tireTypeName)
	if wheel.tireType == nil then
		-- Check if tiretrackindex present or else use "mud"
		wheel.tireType = REA:DetermineTireType(wheel.tireTrackAtlasIndex)
	end
	
	wheel.widthOffset = getXMLFloat(xmlFile, configKey..".tire#widthOffset") or wheel.widthOffset or 0.0
	wheel.xOffset = getXMLFloat(xmlFile, configKey..".tire#xOffset") or wheel.xOffset or 0
	wheel.maxDeformation = getXMLFloat(xmlFile, configKey..".tire#maxDeformation") or wheel.maxDeformation or 0
	wheel.deformation = 0
	wheel.isCareWheel = Utils.getNoNil(Utils.getNoNil(getXMLBool(xmlFile, configKey..".tire#isCareWheel"), wheel.isCareWheel), true)
	wheel.smoothGroundRadius = getXMLFloat(xmlFile, configKey..".physics#smoothGroundRadius") or math.max(0.6, wheel.width*0.75)
	
	wheel.tireFilename = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".tire#filename", "", getXMLString, wheel.tireFilename)
	wheel.tireIsInverted = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".tire#isInverted", "", getXMLBool, wheel.tireIsInverted)
	wheel.tireNodeStr = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".tire#node", "", getXMLString, nil) or XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".tire#"..key, "", getXMLString, wheel.tireNodeStr)
	wheel.outerRimFilename = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".outerRim#filename", "", getXMLString, wheel.outerRimFilename)
	wheel.outerRimNodeStr = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".outerRim#node", "", getXMLString, wheel.outerRimNodeStr) or "0|0"
	wheel.outerRimWidthAndDiam = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".outerRim#widthAndDiam", "", getXMLString,  wheel.outerRimWidthAndDiam, StringUtil.getVectorNFromString, 2)
	wheel.outerRimScale = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".outerRim#scale", "", getXMLString, wheel.outerRimScale, StringUtil.getVectorNFromString, 3)
	wheel.innerRimFilename = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".innerRim#filename", "", getXMLString, wheel.innerRimFilename)
	wheel.innerRimNodeStr = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".innerRim#node", "", getXMLString, nil) or XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".innerRim#"..key, "", getXMLString, wheel.innerRimNodeStr)
	wheel.innerRimWidthAndDiam = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".innerRim#widthAndDiam", "", getXMLString, wheel.innerRimWidthAndDiam, StringUtil.getVectorNFromString, 2)
	wheel.innerRimOffset = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".innerRim#offset", "", getXMLFloat, wheel.innerRimOffset) or 0
	wheel.innerRimScale = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".innerRim#scale", "", getXMLString, wheel.innerRimScale, StringUtil.getVectorNFromString, 3);
	wheel.additionalFilename = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".additional#filename", "", getXMLString, wheel.additionalFilename)
	wheel.additionalNodeStr = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".additional#node", "", getXMLString, nil) or XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".additional#"..key, "", getXMLString, wheel.additionalNodeStr)
	wheel.additionalOffset = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".additional#offset", "", getXMLFloat,  wheel.additionalOffset) or 0
	wheel.additionalScale = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".additional#scale", "", getXMLString, wheel.additionalScale, StringUtil.getVectorNFromString, 3)
	wheel.additionalMass = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".additional#mass", "", getXMLFloat, wheel.additionalMass) or 0
	wheel.additionalWidthAndDiam = XMLUtil.getXMLOverwrittenValue(xmlFile, configKey, ".additional#widthAndDiam", "", getXMLString, wheel.additionalWidthAndDiam, StringUtil.getVectorNFromString, 2)
end


-----------------------------------------------------------------------------------	
-- Edited loadWheelPhysicsData
-----------------------------------------------------------------------------------
function Wheels:loadWheelPhysicsData(xmlFile, key, wheelnamei, wheel)
	local physicsKey = wheelnamei .. ".physics"
	if wheel.repr ~= nil then
		wheel.node = self:getParentComponent(wheel.repr)
		if wheel.node ~= 0 then
			XMLUtil.checkDeprecatedXMLElements(xmlFile, self.configFileName, key..wheelnamei.."#steeringNode", string.format("vehicle.wheels.wheelConfigurations.wheelConfiguration.wheels%s.steering#node", wheelnamei))
			local driveNodeStr = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#driveNode", getXMLString, nil, nil, nil)
			wheel.driveNode = I3DUtil.indexToObject(self.components, driveNodeStr, self.i3dMappings)
			if wheel.driveNode == wheel.repr then
				g_logManager:xmlWarning(self.configFileName, "repr and driveNode may not be equal for '%s'. Using default driveNode instead!", key.."."..physicsKey)
				wheel.driveNode = nil
			end
			wheel.linkNode = I3DUtil.indexToObject(self.components, ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#linkNode", getXMLString, nil, nil, nil), self.i3dMappings)
			if wheel.driveNode == nil then
				-- create a new repr and use repr as drivenode
				local newRepr = createTransformGroup("wheelReprNode")
				local reprIndex = getChildIndex(wheel.repr)
				link(getParent(wheel.repr), newRepr, reprIndex)
				setTranslation(newRepr, getTranslation(wheel.repr))
				setRotation(newRepr, getRotation(wheel.repr))
				setScale(newRepr, getScale(wheel.repr))
				wheel.driveNode = wheel.repr
				link(newRepr, wheel.driveNode)
				setTranslation(wheel.driveNode, 0, 0, 0)
				setRotation(wheel.driveNode, 0, 0, 0)
				setScale(wheel.driveNode, 1, 1, 1)
				wheel.repr = newRepr
			end
			if wheel.driveNode ~= nil then
				local driveNodeDirectionNode = createTransformGroup("driveNodeDirectionNode")
				link(getParent(wheel.repr), driveNodeDirectionNode)
				setWorldTranslation(driveNodeDirectionNode, getWorldTranslation(wheel.driveNode))
				setWorldRotation(driveNodeDirectionNode, getWorldRotation(wheel.driveNode))
				wheel.driveNodeDirectionNode = driveNodeDirectionNode
			end
			if wheel.linkNode == nil then
				wheel.linkNode = wheel.driveNode
			end
			wheel.yOffset = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#yOffset", getXMLFloat, 0.0, nil, nil)
			if wheel.yOffset ~= 0 then
				-- move drivenode in y direction. Use convert yOffset from driveNode local space to driveNodeParent local space to translate according to directions
				setTranslation(wheel.driveNode, localToLocal(wheel.driveNode, getParent(wheel.driveNode), 0, wheel.yOffset, 0))
			end
			wheel.showSteeringAngle = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#showSteeringAngle", getXMLBool, true, nil, nil)
			wheel.suspTravel = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#suspTravel", getXMLFloat, 0.01, nil, nil)
			local initialCompression = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#initialCompression", getXMLFloat, nil, nil, nil)
			if initialCompression ~= nil then
				wheel.deltaY = (1-initialCompression*0.01)*wheel.suspTravel
			else
				wheel.deltaY = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#deltaY", getXMLFloat, 0.0, nil, nil)
			end
			wheel.spring = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#spring", getXMLFloat, 0, nil, nil)*Vehicle.SPRING_SCALE
			wheel.torque = 0
			wheel.brakeFactor = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#brakeFactor", getXMLFloat, 1, nil, nil)
			wheel.autoHoldBrakeFactor = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#autoHoldBrakeFactor", getXMLFloat, wheel.brakeFactor, nil, nil)
			wheel.damperCompressionLowSpeed = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#damperCompressionLowSpeed", getXMLFloat, nil, nil, nil)
			wheel.damperRelaxationLowSpeed = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#damperRelaxationLowSpeed", getXMLFloat, nil, nil, nil)
			if wheel.damperRelaxationLowSpeed == nil then
				wheel.damperRelaxationLowSpeed = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#damper", getXMLFloat, Utils.getNoNil(wheel.damperCompressionLowSpeed, 0), nil, nil)
			end
			-- by default, the high speed relaxation damper is set to 90% of the low speed relaxation damper
			wheel.damperRelaxationHighSpeed = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#damperRelaxationHighSpeed", getXMLFloat, wheel.damperRelaxationLowSpeed * 0.7, nil, nil)
			-- by default, we set the low speed compression damper to 90% of the low speed relaxation damper
			if wheel.damperCompressionLowSpeed == nil then
				wheel.damperCompressionLowSpeed = wheel.damperRelaxationLowSpeed * 0.9
			end
			-- by default, the high speed compression damper is set to 20% of the low speed compression damper
			wheel.damperCompressionHighSpeed = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#damperCompressionHighSpeed", getXMLFloat, wheel.damperCompressionLowSpeed * 0.2, nil, nil)
			wheel.damperCompressionLowSpeedThreshold = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#damperCompressionLowSpeedThreshold", getXMLFloat, 0.1016, nil, nil) -- default 4 inch / s
			wheel.damperRelaxationLowSpeedThreshold = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#damperRelaxationLowSpeedThreshold", getXMLFloat, 0.1524, nil, nil) -- default 6 inch / s
			wheel.forcePointRatio = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#forcePointRatio", getXMLFloat, 0, nil, nil)
			wheel.driveMode = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#driveMode", getXMLInt, 0, nil, nil)
			wheel.xOffset = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#xOffset", getXMLFloat, 0, nil, nil)
			wheel.transRatio = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#transRatio", getXMLFloat, 0.0, nil, nil)
			wheel.isSynchronized = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#isSynchronized", getXMLBool, true, nil, nil)
			wheel.tipOcclusionAreaGroupId = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#tipOcclusionAreaGroupId", getXMLInt, nil, nil, nil)
			wheel.positionX, wheel.positionY, wheel.positionZ = localToLocal(wheel.driveNode, wheel.node, 0,0,0)
			wheel.useReprDirection = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#useReprDirection", getXMLBool, false, nil, nil)
			wheel.useDriveNodeDirection = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#useDriveNodeDirection", getXMLBool, false, nil, nil)
			wheel.mass = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#mass", getXMLFloat, wheel.mass, nil, nil)
			wheel.radius = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#radius", getXMLFloat, Utils.getNoNil(wheel.radius, 0.5), nil, nil)
			wheel.width = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#width", getXMLFloat, Utils.getNoNil(wheel.width, 0.6), nil, nil)
			wheel.wheelshapeWidth = wheel.width
			wheel.widthOffset = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#widthOffset", getXMLFloat, 0, nil, nil)
			wheel.restLoad = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#restLoad", getXMLFloat, Utils.getNoNil(wheel.restLoad, 1.0), nil, nil) -- [t]
			wheel.maxLongStiffness = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#maxLongStiffness", getXMLFloat, Utils.getNoNil(wheel.maxLongStiffness, 30.0), nil, nil) -- [t / rad]
			wheel.maxLatStiffness = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#maxLatStiffness", getXMLFloat, Utils.getNoNil(wheel.maxLatStiffness, 40.0), nil, nil) -- xml is ratio to restLoad [1/rad], final value is [t / rad]
			wheel.maxLatStiffnessLoad = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#maxLatStiffnessLoad", getXMLFloat, Utils.getNoNil(wheel.maxLatStiffnessLoad, 2), nil, nil) -- xml is ratio to restLoad, final value is [t]
			wheel.frictionScale = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#frictionScale", getXMLFloat, Utils.getNoNil(wheel.frictionScale, 1.0), nil, nil)
			wheel.rotationDamping = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#rotationDamping", getXMLFloat, wheel.mass * 0.035, nil, nil)
			wheel.tireGroundFrictionCoeff = 1.0 -- This will be changed dynamically based on the tire-ground pair

			if wheel.tireType == nil then
				local tireTypeName = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#tireType", getXMLString, nil, nil, nil)
				if tireTypeName == nil then
					-- Check if tiretrackindex present else use "mud"
					wheel.tireType = REA:DetermineTireType(wheel.tireTrackAtlasIndex)
				else
					wheel.tireType = WheelsUtil.getTireType(tireTypeName)
				end
			end

			wheel.fieldDirtMultiplier = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#fieldDirtMultiplier", getXMLFloat, 75, nil, nil)
			wheel.streetDirtMultiplier = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#streetDirtMultiplier", getXMLFloat, -150, nil, nil)
			wheel.minDirtPercentage = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#minDirtPercentage", getXMLFloat, 0.35, nil, nil)
	
			wheel.smoothGroundRadius = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#smoothGroundRadius", getXMLFloat, Utils.getNoNil(wheel.smoothGroundRadius, math.max(0.6, wheel.width*0.75)), nil, nil)
			wheel.versatileYRot = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#versatileYRot", getXMLBool, false, nil, nil)
			wheel.forceVersatility = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#forceVersatility", getXMLBool, false, nil, nil)
			wheel.supportsWheelSink = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#supportsWheelSink", getXMLBool, true, nil, nil)
			wheel.maxWheelSink = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#maxWheelSink", getXMLFloat, math.huge, nil, nil)
	
			wheel.hasTireTracks = ConfigurationUtil.getConfigurationValue(xmlFile, key, wheelnamei, "#hasTireTracks", getXMLBool, false, nil, nil)
			wheel.hasParticles = ConfigurationUtil.getConfigurationValue(xmlFile, key, wheelnamei, "#hasParticles", getXMLBool, false, nil, nil)
	
			local steeringKey = wheelnamei .. ".steering"
			wheel.steeringNode = I3DUtil.indexToObject(self.components, ConfigurationUtil.getConfigurationValue(xmlFile, key, steeringKey, "#node", getXMLString, nil, nil, nil), self.i3dMappings)
			wheel.steeringRotNode = I3DUtil.indexToObject(self.components, ConfigurationUtil.getConfigurationValue(xmlFile, key, steeringKey, "#rotNode", getXMLString, nil, nil, nil), self.i3dMappings)
			wheel.steeringNodeMinTransX = ConfigurationUtil.getConfigurationValue(xmlFile, key, steeringKey, "#nodeMinTransX", getXMLFloat, nil, nil, nil)
			wheel.steeringNodeMaxTransX = ConfigurationUtil.getConfigurationValue(xmlFile, key, steeringKey, "#nodeMaxTransX", getXMLFloat, nil, nil, nil)
			wheel.steeringNodeMinRotY = MathUtil.degToRad(ConfigurationUtil.getConfigurationValue(xmlFile, key, steeringKey, "#nodeMinRotY", getXMLFloat, nil, nil, nil))
			wheel.steeringNodeMaxRotY = MathUtil.degToRad(ConfigurationUtil.getConfigurationValue(xmlFile, key, steeringKey, "#nodeMaxRotY", getXMLFloat, nil, nil, nil))
	
			local fenderKey = wheelnamei .. ".fender"
			wheel.fenderNode = I3DUtil.indexToObject(self.components, ConfigurationUtil.getConfigurationValue(xmlFile, key, fenderKey, "#node", getXMLString, nil, nil, nil), self.i3dMappings)
			wheel.fenderRotMax = ConfigurationUtil.getConfigurationValue(xmlFile, key, fenderKey, "#rotMax", getXMLFloat, nil, nil, nil)
			wheel.fenderRotMin = ConfigurationUtil.getConfigurationValue(xmlFile, key, fenderKey, "#rotMin", getXMLFloat, nil, nil, nil)
	
			local steeringAxleKey = wheelnamei .. ".steeringAxle"
			wheel.steeringAxleScale = ConfigurationUtil.getConfigurationValue(xmlFile, key, steeringAxleKey, "#scale", getXMLFloat, 0, nil, nil)
			wheel.steeringAxleRotMax = MathUtil.degToRad(ConfigurationUtil.getConfigurationValue(xmlFile, key, steeringAxleKey, "#rotMax", getXMLFloat, 0, nil, nil))
			wheel.steeringAxleRotMin = MathUtil.degToRad(ConfigurationUtil.getConfigurationValue(xmlFile, key, steeringAxleKey, "#rotMin", getXMLFloat, -0, nil, nil))
	
			wheel.rotSpeed = MathUtil.degToRad(ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#rotSpeed", getXMLFloat, nil, nil, nil))
			wheel.rotSpeedNeg = Utils.getNoNilRad(ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#rotSpeedNeg", getXMLFloat, nil, nil, nil), nil)
			wheel.rotMax = MathUtil.degToRad(ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#rotMax", getXMLFloat, nil, nil, nil))
			wheel.rotMin = MathUtil.degToRad(ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#rotMin", getXMLFloat, nil, nil, nil))
	
			wheel.rotSpeedLimit = ConfigurationUtil.getConfigurationValue(xmlFile, key, physicsKey, "#rotSpeedLimit", getXMLFloat, nil, nil, nil)
		else
			g_logManager:xmlWarning(self.configFileName, "Invalid repr for wheel '%s'. Needs to be a child of a collision!", key..physicsKey)
		end
	else
		g_logManager:xmlWarning(self.configFileName, "Invalid repr for wheel '%s'!", key..physicsKey)
	end
    return true
end


-----------------------------------------------------------------------------------	
-- Change Speed gauge to RPM gauge
-----------------------------------------------------------------------------------
function REA:updateSpeedGauge(dt)
    local kmh = math.max(0, self.vehicle:getLastSpeed() * self.vehicle.spec_motorized.speedDisplayScale)
    if kmh < 0.5 then
        kmh = 0
    end
    self.speedKmh = kmh -- used again for drawing the speed text

	-- Get max RPM
	local MaxRPM = self.vehicle.spec_motorized.motor:getMaxRpm();

	-- Calculate RPM for speed gauge, this is not a nice calculation...
    if g_server then
		self.vehicle.spec_motorized.motor.RPMGauge = self.vehicle.spec_motorized.motor.lastMotorRpm;
	else
		self.vehicle.spec_motorized.motor.RPMGauge = ((self.vehicle.spec_motorized.motor:getEqualizedMotorRpm() * math.pi / 30)*10)*0.95;
	end;
	-- Smoothe value
	self.vehicle.spec_motorized.motor.RPMGaugeSmoothed = REA:SmootheValue(self.vehicle.spec_motorized.motor.RPMGaugeSmoothed,self.vehicle.spec_motorized.motor.RPMGauge);
	local RPM = self.vehicle.spec_motorized.motor.RPMGaugeSmoothed;

	-- Calculate gauge value
    local gaugeValue = MathUtil.clamp(RPM / (MaxRPM * 1.002), 0, 1)
    local indicatorRotation = MathUtil.lerp(SpeedMeterDisplay.ANGLE.SPEED_GAUGE_MIN, SpeedMeterDisplay.ANGLE.SPEED_GAUGE_MAX, gaugeValue)

    self:updateGaugeIndicator(self.speedIndicatorElement, self.speedIndicatorRadiusX, self.speedIndicatorRadiusY,indicatorRotation)
    self:updateGaugeFillSegments(self.speedGaugeSegmentElements, gaugeValue)
    self:updateGaugePartialSegments(
        self.speedGaugeSegmentPartElements,
        indicatorRotation, 1,
        self.speedGaugeRadiusX, self.speedGaugeRadiusY,
        SpeedMeterDisplay.ANGLE.SPEED_GAUGE_MIN,
        SpeedMeterDisplay.ANGLE.SPEED_GAUGE_SEGMENT_FULL,
        SpeedMeterDisplay.ANGLE.SPEED_GAUGE_SEGMENT_SMALLEST)
end


-----------------------------------------------------------------------------------	
-- Edited update wheel sink
-----------------------------------------------------------------------------------
function REA:REAupdateWheelSink(wheel, dt)
    if wheel.supportsWheelSink then
        if self.isServer and self.isAddedToPhysics then
            local spec = self.spec_wheels

            -- map noise to an asbolute value or to a certain percentage of the wheel radius?
            local maxSink = 0.20
            local sinkTarget = 0

            if wheel.mirroredWheel == nil then
                for _, mirWheel in ipairs(spec.wheels) do
                    if mirWheel.mirroredWheel == nil and mirWheel ~= wheel then -- only the first wheel got the mirrored one
                        local x1, y1, z1 = localToLocal(wheel.node, wheel.repr, 0, 0, 0)
                        local x2, y2, z2 = localToLocal(wheel.node, mirWheel.repr, 0, 0, 0)
                        local diff = math.abs(x1-(-x2)) + math.abs(y1-y2) + math.abs(z1-z2)
                        if diff < 0.25 then
                            wheel.mirroredWheel = mirWheel
                            mirWheel.invMirroredWheel = wheel
                        end
                    end
                end
            end

            local force = false

            if wheel.contact ~= Wheels.WHEEL_NO_CONTACT and self:getLastSpeed() > 0.3 then
                wheel.avgSink = nil
                local width = 0.25 * wheel.width
                local length = 0.25 * wheel.width
                local x,_,z = localToLocal(wheel.driveNode, wheel.repr, 0,0,0)
                local x0,_,z0 = localToWorld(wheel.repr, x + width, 0, z - length)
                local x1,_,z1 = localToWorld(wheel.repr, x - width, 0, z - length)
                local x2,_,z2 = localToWorld(wheel.repr, x + width, 0, z + length)
                local x,z, widthX,widthZ, heightX,heightZ = MathUtil.getXZWidthAndHeight(x0, z0, x1, z1, x2, z2)
                local density, area = FSDensityMapUtil.getFieldValue(x0, z0, x1, z1, x2, z2)
                local terrainValue = 0
                if area > 0 then
                    terrainValue = math.floor(density/area + 0.5)
                end
                wheel.lastTerrainValue = terrainValue
                local noiseValue = 0
                if terrainValue > 0 then
                    local xPerlin = x + 0.5*widthX + 0.5*heightX
                    local zPerlin = z + 0.5*widthZ + 0.5*heightZ
                    -- Round to 1cm to avoid sliding when not moving
                    xPerlin = math.floor(xPerlin*100)*0.01
                    zPerlin = math.floor(zPerlin*100)*0.01

					local perlinNoise;
					-- REA: Get perlin noise settings from each wheel
					if wheel.perlinNoiseSink == nil then
						perlinNoise = Wheels.perlinNoiseSink
					else
						perlinNoise = wheel.perlinNoiseSink
					end;
                    local noiseSink = 0.5 * (1 + getPerlinNoise2D(xPerlin*perlinNoise.randomFrequency, zPerlin*perlinNoise.randomFrequency, perlinNoise.persistence, perlinNoise.numOctaves, perlinNoise.randomSeed))
					-- REA: Get perlin noise settings from each wheel
					if wheel.perlinNoiseWobble == nil then
						perlinNoise = Wheels.perlinNoiseWobble
					else
						perlinNoise = wheel.perlinNoiseWobble
					end;
					local noiseWobble = 0.5 * (1 + getPerlinNoise2D(xPerlin*perlinNoise.randomFrequency, zPerlin*perlinNoise.randomFrequency, perlinNoise.persistence, perlinNoise.numOctaves, perlinNoise.randomSeed))

                    -- estimiate pressure on surface
                    local gravity = 9.81
                    local tireLoad = getWheelShapeContactForce(wheel.node, wheel.wheelShape)
                    if tireLoad ~= nil then
                        local nx,ny,nz = getWheelShapeContactNormal(wheel.node, wheel.wheelShape)
                        local dx,dy,dz = localDirectionToWorld(wheel.node, 0,-1,0)
                        tireLoad = -tireLoad*MathUtil.dotProduct(dx,dy,dz, nx,ny,nz)
                        tireLoad = tireLoad + math.max(ny*gravity, 0.0) * wheel.mass -- add gravity force of tire
                    else
                        tireLoad = 0
                    end
                    tireLoad = tireLoad / gravity
                    local loadFactor = math.min(1.0, math.max(0, tireLoad / wheel.maxLatStiffnessLoad))
                    local wetnessFactor = g_currentMission.environment.weather:getGroundWetness()
                    noiseSink = 0.333*(2*loadFactor + wetnessFactor) * noiseSink
                    noiseValue = math.max(noiseSink, noiseWobble)
                end
                maxSink = Wheels.MAX_SINK[terrainValue] or maxSink

                -- plowing effect
                if terrainValue == 2 and wheel.oppositeWheelIndex ~= nil then
                    local oppositeWheel = spec.wheels[wheel.oppositeWheelIndex]
                    if oppositeWheel.lastTerrainValue ~= nil and oppositeWheel.lastTerrainValue ~= 2 then
                        maxSink = maxSink * 1.3
                    end
                end

                sinkTarget = math.min(0.2*wheel.radiusOriginal, math.min(maxSink, wheel.maxWheelSink) * noiseValue)
            elseif self:getLastSpeed() < 0.3 then
                -- if we are standing still we try to synchronize the left and right wheel radius to avoid wobbeling
                if wheel.mirroredWheel ~= nil then
                    if wheel.avgSink == nil then
                        wheel.avgSink = (wheel.mirroredWheel.sinkTarget + wheel.sinkTarget) / 2
                    end
                    sinkTarget = wheel.avgSink
                    force = wheel.sink ~= wheel.avgSink
                    wheel.sinkTarget = sinkTarget
                elseif wheel.invMirroredWheel ~= nil then
                    if wheel.invMirroredWheel.avgSink ~= nil then
                        sinkTarget = wheel.invMirroredWheel.avgSink
                        force = wheel.sink ~= wheel.invMirroredWheel.avgSink
                        wheel.sinkTarget = sinkTarget
                    end
                end
            end

            if wheel.sinkTarget < sinkTarget then
                wheel.sinkTarget = math.min(sinkTarget, wheel.sinkTarget + (0.05 * math.min(30, math.max(0, self:getLastSpeed()-0.2)) * (dt/1000)))
            elseif wheel.sinkTarget > sinkTarget then
                wheel.sinkTarget = math.max(sinkTarget, wheel.sinkTarget - (0.05 * math.min(30, math.max(0, self:getLastSpeed()-0.2)) * (dt/1000)))
            end

            if math.abs(wheel.sink - wheel.sinkTarget) > 0.001 or force then
                wheel.sink = wheel.sinkTarget

                local radius = wheel.radiusOriginal - wheel.sink
                if radius ~= wheel.radius then
                    wheel.radius = radius
                    if self.isServer then
                        self:setWheelPositionDirty(wheel)
                        local sinkFactor = (wheel.sink/maxSink) * (1 + (0.4 * g_currentMission.environment.weather:getGroundWetness()))
                        wheel.sinkLongStiffnessFactor = (1.0 - (0.10 * sinkFactor))
                        wheel.sinkLatStiffnessFactor  = (1.0 - (0.20 * sinkFactor))
                        self:setWheelTireFrictionDirty(wheel)
                    end
                end
            end
        end
    end
end

if REA.ModActivated == nil then
	addModEventListener(REA);
	REA.ModActivated = true;
	print("mod activated")
end;


